Package: lmdme
Type: Package
Title: Linear Model decomposition for Designed Multivariate Experiments
Version: 1.53.0
Date: 2014-01-31
Author: Cristobal Fresno and Elmer A. Fernandez
Maintainer: Cristobal Fresno <cfresno@bdmg.com.ar>
Description: linear ANOVA decomposition of Multivariate Designed
        Experiments implementation based on limma lmFit. Features:
        i)Flexible formula type interface, ii) Fast limma based
        implementation, iii) p-values for each estimated coefficient
        levels in each factor, iv) F values for factor effects and v)
        plotting functions for PCA and PLS.
License: GPL (>=2)
URL: http://www.bdmg.com.ar/?page_id=38
Imports: stats, methods, limma
Depends: R (>= 2.14.1), pls, stemHypoxia
Enhances: parallel
Collate: 'lmdme-Class.R' 'lmdme-lmdme.R' 'lmdme-getters.R'
        'lmdme-printshow.R' 'lmdme-padjust.R' 'lmdme-leverage.R'
        'lmdme-permutation.R' 'lmdme-decomposition.R' 'lmdme-biplot.R'
        'lmdme-screeplot.R' 'lmdme-loadingplot.R'
biocViews: Microarray, OneChannel, TwoChannel, Visualization,
        DifferentialExpression, ExperimentData, Cancer
git_url: https://git.bioconductor.org/packages/lmdme
git_branch: devel
git_last_commit: 885461c
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
NeedsCompilation: no
Packaged: 2025-10-30 21:43:43 UTC; biocbuild

#' \code{leverage} test of lmdme objects
#' 
#' This function calculates the leverage test for each individual using the 
#' Principal Component Analysis (comps function) on the coefficients of the
#' given decomposed model term.
#'
#' @param object lmdme class object.
#' @param comps a numeric vector indicating the PCA component indexes to keep. 
#'  Default the first two components (1:2).
#' @param term a character specifying the model term. 
#' @param level the quantile level. Default value 0.95
#'
#' @return data.frame with the following fields
#'  \item{leverage}{numeric for the corresponding row leverage}
#'  \item{over}{logical indicating if the leverage > quantile(leverage,level) 
#'  for the given decomposed term}
#'
#' @seealso \code{\link{prcomp}}, \code{\link{quantile}}
#'
#' @author Cristobal Fresno and Elmer A Fernandez
#'
#' @references Tarazona S, Prado-Lopez S, Dopazo J, Ferrer A, Conesa A, 
#'  Variable Selection for Multifactorial Genomic Data, Chemometrics and
#'  Intelligent Laboratory Systems, 110:113-122 (2012)  
#'
#' @examples
#' {
#' data(stemHypoxia)
#' 
#' ##Just to make a balanced dataset in the Fisher sense (2 samples per 
#' ## time*oxygen levels)
#' design<-design[design$time %in% c(0.5, 1, 5) & design$oxygen %in% c(1,5,21),]
#' design$time<-as.factor(design$time)
#' design$oxygen<-as.factor(design$oxygen)
#' rownames(M)<-M[, 1]
#' 
#' ##Keeping appropriate samples only
#' M<-M[, colnames(M) %in% design$samplename] 
#' 
#' ##ANOVA decomposition
#' fit<-lmdme(model=~time+oxygen+time:oxygen, data=M, design=design)
#' 
#' ##Leverages for the first two Principal Components and q95 (default value). 
#' ##Leverages for the first three Principal Components and q99.
#' leverages2PCDefault<-leverage(fit, term="time:oxygen")
#' leverages3PCq99<-leverage(fit, comps=1:3, term="time:oxygen", level=0.99)
#' }
#'
#' @exportMethod leverage
#' @docType methods
#' @name leverage
#' @rdname lmdme-leverage
#' @aliases leverage-methods
setGeneric(name="leverage", def=function(object, comps=1:2, term, level=0.95){
  standardGeneric("leverage")
})
#'
#' @name leverage
#' @rdname lmdme-leverage
#' @inheritParams leverage
#' @aliases leverage,lmdme-method
setMethod(f="leverage", signature="lmdme", definition=function(object,
  comps=1:2, term, level=0.95){
  ##Check for term presence
  if(missing(term)){
    stop("ERROR: missing term")
  }
  ##Obtain the leverages
  pca<-prcomp(coefficients(object, term=term))
  out<-data.frame(leverage=apply(pca$x[, comps]^2, 1, sum))
  out$over<-out$leverage > quantile(out$leverage, level)
  return(out)
})

#' Getters for lmdme object
#'
#' To obtain lmdme slot information, according to the given function call (see
#' Values). If a term parameter is not specified, it will return all the
#' available terms. Otherwise, just the one specified.
#' 
#' @param object lmdme class object.
#' @param term character with the corresponding term/s to return. Default value
#' is NULL in order to return every available term/s.
#' @param drop should try to drop list structure if length==1? Default value
#' is TRUE 
#' 
#' @return according to the call one of the following objects can be returned
#'  \item{design}{experiment design data.frame used.}
#'  \item{model}{decomposed formula used.}
#'  \item{modelDecomposition}{list of decomposed model formulas.}
#'  \item{residuals, resid, coef, coefficients, fitted, fitted.values, 
#'  p.values or F.p.values}{list of appropriate slot where each item is a matrix
#'  that will have G rows (individuals) x k columns (levels of the corresponding
#'  model term).}
#'  \item{components}{list with corresponding PCA or PLSR terms according to 
#'  the decomposition function call.}
#'  \item{componentsType}{character name vector with the information of the 
#'  component calculations.}
#'  
#' @seealso \code{\link{lmdme}}, \code{\link{decomposition}}, 
#'  \code{\link{print}}, \code{\link{show}}
#'
#' @author Cristobal Fresno and Elmer A Fernandez
#'
#' @examples
#' {
#' data(stemHypoxia)
#' 
#' ##Just to make a balanced dataset in the Fisher sense (2 samples per 
#' ## time*oxygen levels)
#' design<-design[design$time %in% c(0.5, 1, 5) & design$oxygen %in% c(1,5,21),]
#' design$time<-as.factor(design$time)
#' design$oxygen<-as.factor(design$oxygen)
#' rownames(M)<-M[, 1]
#'
#' ##Keeping appropriate samples only
#' M<-M[, colnames(M) %in% design$samplename] 
#' 
#' ##ANOVA decomposition
#' fit<-lmdme(model=~time+oxygen+time:oxygen, data=M, design=design)
#' 
#' ##Let's inspect how the decomposition process was carried out:
#' ##a) The model formula used
#' ##b) The design data.frame used 
#' ##c) The decomposition itself
#' fit.model<-model(fit) 
#' fit.design<-design(fit)
#' fit.modelDecomposition<-modelDecomposition(fit)
#' 
#' ##Getting the specific "time" term coefficients, p-values or F-values.
#' ## Omit "term" parameter for all available terms.
#' timeCoef<-coef(fit,term="time")  
#' fit.p.values<-p.values(fit,term="time") 
#' fit.f.values<-F.p.values(fit,term="time") 
#' 
#' ##Getting the residuals or fitted values, for the interaction "time:oxygen"
#' ## term. Omit "term" parameter for all available terms.
#' interactionResid<-resid(fit, term="time:oxygen") 
#' interactionFit<-fitted(fit, term="time:oxygen")
#' }
#' 
#' @exportMethod fitted.values
#' @docType methods
#' @name fitted.values
#' @rdname lmdme-getters
#' @importFrom stats fitted.values
#' @usage \S4method{fitted.values}{lmdme}(object, term=NULL, drop=TRUE)
#' @aliases fitted.values,lmdme-method
setMethod(f="fitted.values", signature="lmdme", definition=function(object,
  term=NULL, drop=TRUE){  
  ##If Term == NULL the full decomposed fitted.values
  if(is.null(term)){
    term<-names(object@coefficients)
  }else{
    ##Check for term in model
    if(!any(term %in% names(object@coefficients))){
      stop("ERROR: ", toString(term), " not in model: ", object@model)
    }
  }
    
  ##Get the fitted values for the requested term/s
  output<-lapply(as.list(term), function(termino){
    ##The intercept is a special case, for the rest is the term-1 for the model
    ##matrix. Then hat(y) = X(the model matrix) %*% hat(beta)
    if(termino == "(Intercept)"){
      mm<-model.matrix(as.formula(paste("~ 1",sep="")), data=object@design)
    }else{
      mm<-model.matrix(as.formula(paste("~", termino, "-1", sep="")),
        data=object@design)
    }
      return(t(apply(object@coefficients[[termino]], MARGIN=1, FUN=function(x,
        mm){mm%*%x}, mm)))
    })
    
  names(output)<-term

  ##Check for drop parameter
  if(drop & length(output)==1){
    output<-output[[1]]
  }
  
  return(output)
})
#'
#' @exportMethod fitted
#' @name fitted
#' @rdname lmdme-getters
#' @inheritParams fitted.values
#' @importFrom stats fitted
#' @usage \S4method{fitted}{lmdme}(object, term=NULL, drop=TRUE)
#' @aliases fitted,lmdme-method
setMethod(f="fitted", signature = "lmdme", definition=function(object,
  term=NULL, drop=TRUE){
  return(fitted.values(object, term, drop))
})
#'
#' @exportMethod coef
#' @name coef
#' @rdname lmdme-getters
#' @inheritParams fitted.values
#' @importFrom stats coef
#' @usage \S4method{coef}{lmdme}(object, term=NULL, drop=TRUE)
#' @aliases coef,lmdme-method
setMethod(f="coef", signature = "lmdme", definition = function(object,
  term=NULL, drop=TRUE){
  ##If Term == NULL the full decomposed coefficients
  if(is.null(term)){
    out<-object@coefficients
  }else{
    ##Else search for the term over the decomposed coefficients
    if(all(term %in% names(object@coefficients))){
      out<-object@coefficients[term]
    }else{
      stop("ERROR: ", toString(term), " not in model: ", object@model)
    }
  }

  ##Check for drop parameter
  if(drop & length(out)==1){
    out<-out[[1]]
  }

  return(out)
})
#'
#' @exportMethod coefficients
#' @name coefficients
#' @rdname lmdme-getters
#' @inheritParams fitted.values
#' @importFrom stats coefficients
#' @usage \S4method{coefficients}{lmdme}(object, term=NULL, drop=TRUE)
#' @aliases coefficients,lmdme-method
setMethod(f="coefficients", signature="lmdme", definition=function(object,
  term=NULL, drop=TRUE){
  return(coef(object, term, drop))
})
#'
#' @exportMethod resid
#' @name resid
#' @rdname lmdme-getters
#' @inheritParams fitted.values
#' @importFrom stats resid
#' @usage \S4method{resid}{lmdme}(object, term=NULL, drop=TRUE)
#' @aliases resid,lmdme-method
setMethod(f="resid", signature = "lmdme", definition=function(object,
  term=NULL, drop=TRUE){
  ##If Term == NULL the full decomposed residuals
  if(is.null(term)){
    out<-object@residuals
  }else{
    ##Else search for the term over the decomposed residuals  
    if(all(term %in% names(object@residuals))){
      out<-object@residuals[term]
    }else{
      stop("ERROR: ", toString(term), " not in model: ", object@model)
    }
  }

  ##Check for drop parameter
  if(drop & length(out)==1){
    out<-out[[1]]
  }

  return(out)
})
#'
#' @exportMethod residuals
#' @name residuals
#' @rdname lmdme-getters
#' @inheritParams fitted.values
#' @importFrom stats residuals
#' @usage \S4method{residuals}{lmdme}(object, term=NULL, drop=TRUE)
#' @aliases residuals,lmdme-method
setMethod(f="residuals", signature="lmdme", definition=function(object,
  term=NULL, drop=TRUE){
  return(resid(object, term, drop))
})
#'
#' @exportMethod F.p.values
#' @name F.p.values
#' @rdname lmdme-getters
#' @inheritParams fitted.values
#' @usage F.p.values(object, term=NULL, drop=TRUE)
#' @aliases F.p.values-methods
setGeneric(name="F.p.values", def=function(object, term=NULL, drop=TRUE){
  standardGeneric("F.p.values")
})
#'
#' @name F.p.values
#' @rdname lmdme-getters
#' @inheritParams fitted.values
#' @usage \S4method{F.p.values}{lmdme}(object, term=NULL, drop=TRUE)
#' @aliases F.p.values,lmdme-method
setMethod(f="F.p.values", signature="lmdme", definition=function(object,
  term=NULL, drop=TRUE){
  ##If Term == NULL the full decomposed F.p.values    
  if(is.null(term)){
    out<-object@F.p.values
  }else{
    ##Else search for the term over the F.p.values  
    if(all(term %in% names(object@F.p.values))){
      out<-object@F.p.values[term]
    }else{
      stop("ERROR: ", toString(term), " not in model: ", object@model)
    }
  }
  
  ##Check for drop parameter
  if(drop & length(out)==1){
    out<-out[[1]]
  }

  return(out)
})
#'
#' @exportMethod p.values
#' @name p.values
#' @rdname lmdme-getters
#' @inheritParams fitted.values
#' @usage p.values(object, term=NULL, drop=TRUE)
#' @aliases p.values-methods
setGeneric(name="p.values", def=function(object, term=NULL, drop=TRUE){
  standardGeneric("p.values")
})
#'
#' @name p.values
#' @rdname lmdme-getters
#' @inheritParams fitted.values
#' @usage \S4method{p.values}{lmdme}(object, term=NULL, drop=TRUE)
#' @aliases p.values,lmdme-method
setMethod(f="p.values", signature="lmdme", definition=function(object,
  term=NULL, drop=TRUE){
  ##If Term == NULL the full decomposed p.values
  if(is.null(term)){
    out<-object@p.values
  }else{
    ##Else search for the term over the p.values  
    if(all(term %in% names(object@p.values))){
      out<-object@p.values[term]
    }else{
      stop("ERROR: ", toString(term), " not in model: ", object@model)
    }
  }

  ##Check for drop parameter
  if(drop & length(out)==1){
    out<-out[[1]]
  }

  return(out)
})
#'
#' @exportMethod modelDecomposition
#' @name modelDecomposition
#' @rdname lmdme-getters
#' @inheritParams fitted.values
#' @usage modelDecomposition(object, term=NULL, drop=TRUE)
#' @aliases modelDecomposition-methods
setGeneric(name="modelDecomposition", def=function(object, term=NULL,
  drop=TRUE){
  standardGeneric("modelDecomposition")
})
#'
#' @name modelDecomposition
#' @rdname lmdme-getters
#' @inheritParams fitted.values
#' @usage \S4method{modelDecomposition}{lmdme}(object, term=NULL, drop=TRUE)
#' @aliases modelDecomposition,lmdme-method
setMethod(f="modelDecomposition", signature="lmdme", definition=function(object,
  term=NULL, drop=TRUE){
  ##If Term == NULL the full decomposed models
  if(is.null(term)){
    out<-object@modelDecomposition
  }else{
    ##Else search for the term over the p.values  
    if(all(term %in% names(object@modelDecomposition))){
      out<-object@modelDecomposition[term]
    }else{
      stop("ERROR: ", toString(term), " not in model: ", object@model)
    }
  }

  ##Check for drop parameter
  if(drop & length(out)==1){
    out<-out[[1]]
  }

  return(out)
})
#'
#' @exportMethod components
#' @name components
#' @rdname lmdme-getters
#' @inheritParams fitted.values
#' @usage components(object, term=NULL, drop=TRUE)
#' @aliases components-methods
setGeneric(name="components", def=function(object, term=NULL, drop=TRUE){
  standardGeneric("components")
})
#'
#' @name components
#' @rdname lmdme-getters
#' @inheritParams fitted.values
#' @usage \S4method{components}{lmdme}(object, term=NULL, drop=TRUE)
#' @aliases components,lmdme-method
setMethod(f="components", signature="lmdme", definition=function(object,
  term=NULL, drop=TRUE){
  ##If Term == NULL the full decomposed models
  if(is.null(term)){
    out<-object@components
  }else{
    ##Else search for the term over the p.values  
    if(all(term %in% names(object@components))){
      out<-object@components[term]
    }else{
      stop("ERROR: ", toString(term), " not in model/s: ",
        toString(names(object@components)))
    }
  }
  
  ##Check for drop parameter
  if(drop & length(out)==1){
    out<-out[[1]]
  }

  return(out)
})
#'
#' @exportMethod componentsType
#' @name componentsType
#' @rdname lmdme-getters
#' @inheritParams fitted.values
#' @usage componentsType(object)
#' @aliases componentsType-methods
setGeneric(name="componentsType", def=function(object){
  standardGeneric("componentsType")
})
#'
#' @name componentsType
#' @rdname lmdme-getters
#' @inheritParams fitted.values
#' @usage \S4method{componentsType}{lmdme}(object)
#' @aliases componentsType,lmdme-method
setMethod(f="componentsType", signature="lmdme", definition=function(object){
  return(object@componentsType)
})
#'
#' @exportMethod model
#' @name model
#' @rdname lmdme-getters
#' @inheritParams fitted.values
#' @usage model(object)
#' @aliases model-methods
setGeneric(name="model", def=function(object){standardGeneric("model")})
#'
#' @name model
#' @rdname lmdme-getters
#' @inheritParams fitted.values
#' @usage \S4method{model}{lmdme}(object)
#' @aliases model,lmdme-method
setMethod(f="model", signature="lmdme", definition=function(object){
  return(object@model)
})
#'
#' @exportMethod design
#' @name design
#' @rdname lmdme-getters
#' @inheritParams fitted.values
#' @usage design(object)
#' @aliases design-methods
setGeneric(name="design", def=function(object){standardGeneric("design")})
#'
#' @name design
#' @rdname lmdme-getters
#' @inheritParams fitted.values
#' @usage \S4method{design}{lmdme}(object)
#' @aliases design,lmdme-method
setMethod(f="design", signature="lmdme", definition=function(object){
  return(object@design)
})

#' \code{loadingplot} of interaction PCA decomposed lmdme object
#' 
#' This function plots the PCA loadings for a given interaction (A:B) lmdme
#' object's components slot, for the given "pc" component. The user can choose
#' which term (A or B) is used for x-axis and y-axis functions (B or A)
#' respectively.
#'
#' @param object lmdme class object.
#' @param term.x,term.y character indicating the model principal factor for the
#'  interaction term (term.x:term.y or term.y:term.x) for the corresponding x or
#'  y axis.
#' @param pc integer indicating which principal component loading is to be 
#'  plotted on the y-axis. Default value is 1.
#' @param col which color to use for each level present in term.y. 
#' @param ord.x numeric indicating the term.x levels order, for plotting
#'  purposes. If missing, the levels order is used.
#' @param ... additional parameters for matplot.
#'
#' @return loading plot of the selected interaction (term.x:term.y) 
#'  lmdme object's components slot, if PCA decomposition was applied.
#'
#' @author Cristobal Fresno and Elmer A Fernandez
#'
#' @examples
#' {
#' data(stemHypoxia)
#' 
#' ##Just to make a balanced dataset in the Fisher sense (2 samples per 
#' ## time*oxygen levels) 
#' design<-design[design$time %in% c(0.5,1,5) & design$oxygen %in% c(1,5,21), ]
#' design$time<-as.factor(design$time)
#' design$oxygen<-as.factor(design$oxygen)
#' rownames(M)<-M[, 1]
#' 
#' #Keeping appropriate samples only
#' M<-M[, colnames(M) %in% design$samplename] 
#' 
#' ##ANOVA decomposition
#' fit<-lmdme(model=~time+oxygen+time:oxygen, data=M, design=design)
#' 
#' ##ASCA for all the available terms, on those subjects/genes where at least
#' ##one interaction coefficient is statistically different from zero (F-test
#' ##on the coefficients).
#' id<-F.p.values(fit, term="time:oxygen")<0.001
#' decomposition(fit, decomposition="pca", scale="row", subset=id) 
#'
#' \dontrun{
#'  loadingplot(fit, term.x="time", term.y="oxygen") 
#'
#'  ##Or change the axis order
#'  loadingplot(fit, term.x="oxygen", term.y="time")
#'
#'  ##Or change the PC to display
#'  loadingplot(fit, term.x="time", term.y="oxygen", pc=2)
#'
#'  ##Or the order of x-levels
#'  loadingplot(fit, term.x="time", term.y="oxygen", ord.x=3:1)
#' }
#' }
#'
#' @exportMethod loadingplot
#' @importFrom pls loadingplot 
#' @docType methods
#' @name loadingplot
#' @rdname lmdme-loadingplot
#' @usage \S4method{loadingplot}{lmdme}(object, term.x, term.y, pc=1, ord.x, col, ...)
#' @aliases loadingplot,lmdme-method
stopifnot(require(pls))
setMethod(f="loadingplot",signature="lmdme", definition=function(object, term.x,
  term.y, pc=1, ord.x, col, ...){
  ##Check for PCA decomposition
  if(length(componentsType(object))==0){
     stop("No available PCA decomposed model. Please run decomposition(x)")
  }
  if(componentsType(object)["decomposition"]!="pca"){
     stop(paste("No available PCA decomposed model. Please run",
      "decomposition(x,decomposition=\"pca\")"))
  }

  ##Check term presence and appropriate order
  ## Term parameter were passed to the function
  stopifnot(!missing(term.x) & !missing(term.y))
  term <- c(paste(term.x,":",term.y,sep=""), paste(term.y,":",term.x,sep=""))
  if(!any(term %in% names(object@components))){
    stop("Term specification ", term[1], " not in modelDecomposition(object).",
      "Maybe misspelled?")}
  
  ##Get term positions and levels
  termPos<-which(names(object@components) %in% term)
  termxPos<-which(term %in% names(object@components))
  levelsY<-levels(object@design[, term.y])
  levelsX<-levels(object@design[, term.x])

  ##Get the loadings and parse them for plotting
  pcaLoad<-loadings(object@components[[termPos]])
  pcaLoad<-sapply(levelsY, function(y){
    sapply(levelsX,function(x){
      pos<-switch(termxPos, 
        '1'=rownames(pcaLoad)==paste(term.x, x, ":", term.y, y, sep=""), 
        '2'=rownames(pcaLoad)==paste(term.y, y, ":", term.x, x, sep=""))
      pcaLoad[pos,pc]
    })
  })
  
  ##Finally the loadingplot
  if(missing(ord.x)){ord.x<-1:nrow(pcaLoad)}
  if(missing(col)){col<-1:ncol(pcaLoad)}
    variance<-round(object@components[[termPos]]$sdev[pc] /
      sum(object@components[[termPos]]$sdev)*100, digits=2)
    matplot(pcaLoad[ord.x,], type="b", main=term[termxPos], axes=FALSE, 
      ylab=paste("PC-", pc, "- Exp. Var. (", variance, "%)", sep=""),
      xlab=term.x, pch=16, col=col, ...)
  box()
  axis(side=2)
  axis(1, at=1:nrow(pcaLoad), labels=rownames(pcaLoad)[ord.x])
  legend("topright", legend=paste(term.y, levelsY, sep="="), pch=16,
    box.col="transparent", col=col)
})

#' Plot a \code{biplot} of a lmdme object
#' 
#' Plot a biplot over each decomposed "pca" or "plsr" present in lmdme
#' component object's slot.
#'
#' @param x lmdme class object.
#' @param comp a two component vector with the PC components to plot. Default 
#'  comp=1:2.
#' @param xlab character for the x-label title for PCA biplots.
#' @param ylab character for the y-label title for PCA biplots.
#' @param term character with the corresponding term/s for biploting. Default 
#'  value is NULL in order to obtain every available biplot/s.
#' @param mfcol numeric vector for par layout. If missing mfcol=c(1,2) will be
#'  used if more than one biplot is available. Use  mfcol==NULL to override par
#'  call inside biplot function.
#' @param xlabs,ylabs vector of character strings to label the first/second set
#'  of points. The default is to use dimname of "x"/"y", or "1:n" if the dimname
#'  is NULL for the respective set of points. If a single character is
#'  passed e.g. "o", the same character is used for all the points.
#' @param which character to indicate the type of biplot to use when plsr
#'  decomposition is applied. Default value is "x" (X scores and loadings), "y"
#'  for (Y scores and loadings), "scores" (X and Y scores) or "loadings" (X and
#'  Y loadings). See \code{\link{biplot.mvr}} for details.
#' @param ... additional parameters for \code{\link{biplot.prcomp}}(pca) or
#'  \code{\link{biplot.mvr}}(plsr)
#'
#' @return plotted biplot/s of the component/s of the given lmdme object. If
#'  \code{\link{par}}() is called before this function, the biplots can be
#'  arranged in the same window  
#'
#' @seealso \code{\link{prcomp}}, \code{\link{plsr}},
#'  \code{\link{biplot.princomp}}, \code{\link{biplot.mvr}}
#'
#' @author Cristobal Fresno and Elmer A Fernandez
#'
#' @examples
#' {
#' data(stemHypoxia)
#' 
#' ##Just to make a balanced dataset in the Fisher sense (2 samples per 
#' ## time*oxygen levels) 
#' design<-design[design$time %in% c(0.5,1,5) & design$oxygen %in% c(1,5,21), ]
#' design$time<-as.factor(design$time)
#' design$oxygen<-as.factor(design$oxygen)
#' rownames(M)<-M[, 1]
#' 
#' #Keeping appropriate samples only
#' M<-M[, colnames(M) %in% design$samplename] 
#' 
#' ##ANOVA decomposition
#' fit<-lmdme(model=~time+oxygen+time:oxygen, data=M, design=design)
#' 
#' ##ASCA for all the available terms, over those subjects/genes where at least
#' ##one interaction coefficient is statistically different from zero (F-test
#' ##on coefficients).
#' id<-F.p.values(fit, term="time:oxygen")<0.001
#' decomposition(fit, decomposition="pca",scale="row",subset=id) 
#' 
#' \dontrun{
#' ##Does not call par inside
#' par(mfrow=c(2,2))
#' biplot(fit, xlabs="o", mfcol=NULL) 
#' 
#' ##Just the term of interest
#' biplot(fit, xlabs="o", term="time")
#'
#' ##In separate graphics
#' biplot(fit, xlabs="o", term=c("time", "oxygen"), mfcol=c(1,1))
#' 
#' ##All terms in the same graphic
#' biplot(fit, xlabs="o", mfcol=c(1,3))
#' }
#' }
#'
#' ##Now using plsr on interaction coefficients
#' decomposition(fit, decomposition="plsr", term="time:oxygen", scale="row",
#'  subset=id)
#'
#' \dontrun{
#' par(mfrow=c(2,2))
#' 
#' ##plsr biplot by default which="x"
#' biplot(fit, which="x", mfcol=NULL) 
#' 
#' ##Other alternatives to which
#' biplot(fit, which="y", mfcol=NULL)
#' biplot(fit, which="scores", mfcol=NULL)
#' biplot(fit, which="loadings", mfcol=NULL, xlabs="o")
#' }
#'
#' @exportMethod biplot
#' @docType methods
#' @usage \S4method{biplot}{lmdme}(x, comp=1:2, xlab=NULL, ylab=NULL, term=NULL, mfcol, xlabs, ylabs, which, ...)
#' @name biplot
#' @rdname lmdme-biplot
#' @aliases biplot,lmdme-method
setMethod(f="biplot", signature="lmdme", definition=function(x, comp=1:2,
  xlab=NULL, ylab=NULL, term=NULL, mfcol, xlabs, ylabs, which, ...){
  ##Check that is at least one biplot available
  component<-components(x, term=term, drop=FALSE)
  stopifnot(length(component)!=0)

  ##Check for xlabs, ylabs and which presence
  if(missing(xlabs)){xlabs<-NA_character_}
  if(missing(ylabs)){ylabs<-NA_character_}
  if(missing(which)){which<-"x"}
   
  ##Check mfcol to adjust par parameter and create the first biplot
  if(missing(mfcol)){
    if(length(component)==1){
      mfcol<-c(1,1)
    } 
    else{ 
      mfcol<-c(1,2)
    }
  }  
  graphicsPerPar<-prod(mfcol)
  
  ##One plot for each decomposed component
  invisible(sapply(1:length(component), function(index, xlab, ylab){
    ##Tunning the graphic device if required
    if(!is.null(mfcol) & ((index-1) %% (graphicsPerPar)) == 0){
      X11()
      par(mfcol=mfcol)
    }

    ##Check xlabs presence
    xData<-switch(x@componentsType["decomposition"],
      pca=component[[index]]$x,
      plsr={switch(which,
              loadings=component[[index]]$loadings,
              scores=component[[index]]$scores,
              y=component[[index]]$Yscores,
              x=component[[index]]$scores) 
    }) 
    if(!all(is.na(xlabs))){
      if(length(xlabs)==1){
        xlabs<-rep(xlabs,nrow(xData))
      }
    }else{
      ##Check default behavior 
      if(is.null(dimnames(xData))){
        xlabs<-1:nrow(xData)
      }else{
        xlabs<-rownames(xData)
      }
    }

   ##Check ylabs presence
   yData<-switch(x@componentsType["decomposition"],
      pca=component[[index]]$rotation,
      plsr={switch(which,
              loadings=component[[index]]$Yloadings,
              scores=component[[index]]$Yscores,
              y=component[[index]]$Yloadings,
              x=component[[index]]$loadings) 
    }) 
    if(!all(is.na(ylabs))){
      if(length(ylabs)==1){
        ylabs<-rep(ylabs,nrow(yData))
      }
    }else{
      ##Check default behavior 
      if(is.null(dimnames(yData))){
        ylabs<-1:nrow(yData)
      }else{
        ylabs<-rownames(yData)
      }
    }
    
    ##Selecting the type of biplot
    switch(x@componentsType["decomposition"],
      pca={
        variance<-round(100*component[[index]]$sdev /
        sum(component[[index]]$sdev), digits=2)
      
        ##Adjusting labels
        xlab <-ifelse(is.null(xlab), 
          paste("PC", comp[1], "(", variance[comp[1]], "%)", sep=""), xlab)
        ylab <- ifelse(is.null(ylab),
          paste("PC", comp[2], "(", variance[comp[2]], "%)", sep=""), ylab)
        
        biplot(component[[index]], main=names(component)[[index]], choices=comp,
          xlab=xlab, ylab=ylab, xlabs=xlabs, ylabs=ylabs, ...)
     },
     plsr=biplot(component[[index]], comps=comp,main=names(component)[[index]],
       which=which, xlabs=xlabs, ylabs=ylabs, ...)
   )
    
    ##Just to get the reference
    abline(h=0)
    abline(v=0)
    return(NULL)
   }, xlab, ylab))
})

#' High level constructor of lmdme class object
#'
#' Linear model ANOVA decomposition of Designed Multivariate Experiments based 
#' on limma \code{\link{lmFit}} implementation. For example in a two factor
#' experimental design with interaction, the linear model of the i-th
#' observation (gene) can be written: 
#' \cr \eqn{X=\mu+A+B+AB+\epsilon} \cr 
#' where
#' \itemize{ 
#'  \item X stands for the observed value 
#'  \item the intercept \eqn{\mu} 
#'  \item A, B and AB are the first, second and interaction terms respectively
#'  \item The error term \eqn{\epsilon ~ N(0,\sigma^2)}.
#' } 
#' The model is iteratively decomposed in a step by step fashion decomposing
#' one term each time: 
#' \enumerate{ 
#'  \item The intercept is estimated using \eqn{X=\mu+E_1} 
#'  \item The first factor (A) using \eqn{E_1=A+E_2} 
#'  \item The second factor (B) using \eqn{E_2=B+E_3}
#'  \item The interaction (AB) using \eqn{E_3=AB+E_4}.
#' } 
#' For each decomposed step the model, residuals, coefficients, p-values and
#' F-value are stored in a list container, so their corresponding length is
#' equal to the number of model terms + 1 (the intercept). 
#' 
#' @param model formula object to carry out the decomposition.
#' @param data matrix or data.frame with individuals/genes (per rows) and 
#'  samples/conditions (per columns).
#' @param design data.frame with the design of the experiment, (rows) 
#'  samples/conditions as in data columns and as many columns to indicate the
#'  factors present in each sample.
#' @param Bayes Should limma estimate empirical Bayes statistics, i. e., 
#'  moderated t-statistics? Default value is FALSE.
#' @param verbose Should the process progress be printed? Default value is
#' FALSE.
#' @param ... Additional parameters for \code{\link{lmFit}} function.
#'
#' @return 
#'  \item{lmdme}{lmdme class object with the corresponding completed slots 
#'  according to the given model} 
#'   
#' @section Note: use \bold{\code{\link{lmdme}}} high level constructor for the
#'  creation of the class instead of directly calling its constructor by means
#'  of new.
#'
#' @seealso \code{\link{decomposition}}, \code{\link{lmFit}}
#'
#' @author Cristobal Fresno and Elmer A Fernandez
#'
#' @references 
#' \enumerate{
#'  \item Smyth, G. K. (2005). Limma: linear models for microarray data. In: 
#'  Bioinformatics and Computational Biology Solutions using R and
#'  Bioconductor. R. Gentleman, V. Carey, S. Dudoit, R. Irizarry, W.  Huber
#'  (eds), Springer, New York, pages 397--420.
#'  \item Cristobal Fresno, Monica G. Balzarini, Elmer A. Fernandez (2014)
#'  lmdme: Linear Models on Designed Multivariate Experiments in R,
#'  Journal of Statistical Software, 56(7), 1-16.
#'  http://www.jstatsoft.org/v56/i07/.
#' }
#'
#' @examples
#' {
#' data(stemHypoxia)
#' 
#' ##Just to make a balanced dataset in the Fisher sense (2 samples per 
#' ## time*oxygen levels) 
#' design<-design[design$time %in% c(0.5,1,5) & design$oxygen %in% c(1,5,21), ]
#' design$time<-as.factor(design$time)
#' design$oxygen<-as.factor(design$oxygen)
#' rownames(M)<-M[, 1]
#' 
#' #Keeping appropriate samples only
#' M<-M[, colnames(M) %in% design$samplename] 
#' 
#' ##ANOVA decomposition
#' fit<-lmdme(model=~time+oxygen+time:oxygen, data=M, design=design)
#' }
#'
#' @exportMethod lmdme
#' @docType methods
#' @name lmdme
#' @rdname lmdme-lmdme
#' @aliases lmdme-methods
setGeneric(name="lmdme",def = function(model, data, design, Bayes=FALSE,
  verbose=FALSE, ...){standardGeneric("lmdme")})
#'
#' @name lmdme
#' @rdname lmdme-lmdme
#' @inheritParams lmdme
#' @aliases lmdme,formula,ANY,data.frame-method
setMethod(f="lmdme", signature=signature(model="formula", data="ANY",
  design="data.frame"), definition=function(model, data, design, Bayes=FALSE,
  verbose=FALSE,...){
  ## Auxiliary functions 
  ## Print if verbose==TRUE
  if(verbose){
    printnow<-function(...){cat(...);flush.console()}
  }else{
    printnow<-function(...){invisible(NULL)}
  }

  ##Obtain the model parts
  variables<-attr(terms(model),"variables")
  response<-rownames(attr(terms(model), "factors"))[attr(terms(model),
    "response")]
  terminos<-paste(response, "~", c(1, paste(attr(terms(model), "term.labels"),
    "-1")))

  ##Initialization of different slots
  .Object<-new("lmdme")
  .Object@design<-design
  .Object@model<-model
  .Object@residuals<-vector("list", length(terminos))
  names(.Object@residuals)<-c("(Intercept)", attr(terms(model), "term.labels"))
  .Object@p.values<-.Object@residuals
  .Object@F.p.values<-.Object@residuals 
  .Object@coefficients<-.Object@residuals
  .Object@modelDecomposition<-lapply(terminos, as.formula)
  names(.Object@modelDecomposition)<-names(.Object@residuals)
  validObject(.Object)
  
  ##Removing the corresponding term in each step
  invisible(sapply(1:length(terminos), function(term){
    printnow("testing: ", terminos[term], "\n")

    ##Fitting the model
    mm<-model.matrix(object=as.formula(terminos[term]), data=design)
    fit<-lmFit(object=as.matrix(data), design=mm, ...)
    fit$coefficients<-as.matrix(fit$coefficients) ##FIX for NAs

    if(Bayes){
      fit<-eBayes(fit)
    }else{
      ##Without Bayes
      fit$t<-fit$coefficients/(fit$stdev.unscaled*fit$sigma)
      fit$df.prior<-0                        

      fit$p.value<-2*pt(-abs(fit$t), fit$df.residual)      
      F.stat<-classifyTestsF(fit, fstat.only=TRUE)
      
      fit$F<-as.vector(F.stat)
      df1<-attr(F.stat, "df1")
      df2<-attr(F.stat, "df2")
      if(df2[1] > 1e+06){
        fit$F.p.value<-pchisq(df1*fit$F, df1, lower.tail= FALSE)
      }else{
        fit$F.p.value<-pf(fit$F, df1, df2, lower.tail = FALSE)
      }
    }##End without Bayes

    ##Updating object
    .Object@residuals[[term]]<<-data-t(apply(as.matrix(fit$coefficients),
      MARGIN=1, FUN=function(x, mm){mm%*%x}, mm))
    .Object@coefficients[[term]]<<-fit$coefficients
    .Object@p.values[[term]]<<-fit$p.value
    .Object@F.p.values[[term]]<<-fit$F.p.value
    data<<-.Object@residuals[[term]]

    ##Setting names to the residuals
    if(term!=1){
      ##Build Interaction Factor to name the residuals
      form<-as.formula(terminos[term])
      factors<-rownames(attr(terms(form), "factors"))
      if(attr(terms(form), "response")>0){factors<-factors[-1]}
      ifactor<-as.factor(paste(factors[1], as.character(design[,
        factors[1]]), sep=""))
      i<-2
      while(i<=length(factors)){
        ifactor<-ifactor:as.factor(paste(factors[i], as.character(design[,
          factors[i]]), sep=""))
        i<-i+1
      }
      colnames(.Object@residuals[[term]])<<-as.character(ifactor)
    }
    return(NULL)
  }))
  
  validObject(.Object)
  return(.Object)
})

#' lmdme S4 class: Linear Model decomposition for Designed Multivariate
#' Experiments. 
#'
#' Linear Model ANOVA decomposition of Designed Multivariate Experiments based
#' on limma \code{\link{lmFit}} implementation. For example in a two factor
#' experimental design with interaction, the linear model of the i-th
#' observation (gene) can be written: 
#' \cr \eqn{X=\mu+A+B+AB+\epsilon} \cr
#' where 
#' \itemize{ 
#'  \item X stands for the observed value 
#'  \item The intercept \eqn{\mu} 
#'  \item A, B and AB are the first, second and interaction terms respectively
#'  \item The error term \eqn{\epsilon ~ N(0,\sigma^2)}.
#'  } 
#' The model is iterative decomposed in a step by step fashion decomposing
#' one term at each time: 
#' \enumerate{ 
#'  \item The intercept is estimated using \eqn{X=\mu+E_1} 
#'  \item The first factor (A) using \eqn{E_1=A+E_2} 
#'  \item The second factor (B) using \eqn{E_2=B+E_3} 
#'  \item The interaction (AB) using \eqn{E_3=AB+E_4}.
#' } 
#' For each decomposed step the model, residuals, coefficients, p-values and
#' F-values are stored in a list container, so their corresponding length is
#' equal to the number of model terms + 1 (the intercept). 
#'
#' @section Features: 
#' \enumerate{
#'   \item Flexible formula type interface, 
#'   \item Fast limma based implementation based on \code{\link{lmFit}},
#'   \item p values for each estimated coefficient levels in each factor
#'   \item F values for factor effects 
#'   \item Plotting functions for PCA and PLS.
#' }
#'
#' @section Slots: 
#' \itemize{
#'  \item design: data.frame with experimental design.
#'  \item model: formula with the designed model to be decomposed.
#'  \item modelDecomposition: list with the model formula obtained for each 
#'  decomposition step.
#'  \item residuals: list of residual matrices G rows(genes) x N columns
#'  (arrays-designed measurements).
#'  \item coefficients: list of coefficient matrices. Each matrix will have 
#'  G rows(genes) x k columns(levels of the corresponding model term).
#'  \item p.values: list of p-value matrices.
#'  \item F.p.values: list with corresponding F-p-values vectors for each 
#'  individual.
#'  \item components: list with corresponding PCA or PLS components for the 
#'  selected term/s.
#'  \item componentsType: name character vector to keep process trace of the 
#'  variance/covariance components slot: decomposition ("pca" or "pls"), type
#'  ("apca" for ANOVA-PCA or "asca" for ANOVA-SCA) and scale ("none", "row" or
#'  "column") 
#' }
#'
#' @section lmdme-general-functions:
#' \describe{
#'  \item{print, show}{Basic output for lmdme class}
#'  \item{summary}{Basic statistics for lmdme class} 
#'  \item{design, model, modelDecomposition, residuals and coefficients}{Getters
#' for their respective slots.} 
#'  \item{p.values, F.p.values, components and componentsType}{Getters for their
#' respective slots.}
#' }
#'
#' @section ANOVA-linear-decomposition-functions:
#' \describe{
#'  \item{lmdme}{Function that produces the complete ANOVA decomposition based 
#'  on model specification through a formula interface. Technically it's a high
#'  level wrapper of the initialize function.}
#'  \item{modelDecomposition}{Getter for the used decomposed formula in each
#'  step}
#'  \item{p.adjust}{Adjust coefficients p-values for the Multiple Comparison
#'  Tests.}
#'  \item{Fpvalues, pvalues}{Getters for the corresponding associated decomposed
#'   model coefficient statistics in each step, for each observation.}
#'  \item{residuals, resid, coef, coefficients, fitted.values, fitted}{Getters
#'   for the corresponding decomposed model in each step.}
#'  \item{permutation}{Produces the specified lmdme in addition to the required
#'  permuted objects (sampling the columns of data), using the same parameters
#'  to fit the model.}
#' }
#'
#' @section variance-covariance-decomposition-functions:
#' \describe{
#'  \item{decomposition}{Function to perform PCA or PLS on the ANOVA
#'  decomposed terms. PCA can be performed on \eqn{E_1}, \eqn{E_2} or
#'  \eqn{E_3} and it is referred to, as ANOVA-PCA (APCA) but, if it is
#'  performed on the coefficients it is referred to, as ANOVA-SCA (ASCA). On
#'  the other hand PLSR is based on pls library and if it is performed on
#'  coefficients (ASCA like) it uses the identity matrix for output
#'  co-variance maximization or can be carried out on the \eqn{E_{1,2 or 3}}
#'  (APCA like) using the design matrix as the output.}
#'  \item{components}{Getter for PCA or PLS decomposed models.}
#'  \item{componentsType}{Getter for componentsType slot.}
#'  \item{leverage}{Leverage calculation on PCA (APCA or ASCA) terms.}
#'  \item{biplot}{Biplots for PCA or PLSR decomposed terms.}
#'  \item{screeplot}{Screeplot on each PCA decomposed term.}
#'  \item{loadingplot}{Loadingplot for PCA interaction terms.}
#' }
#'
#' @author Cristobal Fresno and Elmer A Fernandez
#' 
#' @seealso \code{\link{lmdme}}, \code{\link{decomposition}}, 
#'  \code{\link{biplot}}, \code{\link{loadingplot}} and additional related
#'  lmdme class functions.
#'
#' @references 
#' \enumerate{
#'  \item Smilde AK, Jansen JJ, Hoefsloot HCJ, Lamer RAN, Van der Greef J, 
#'  Timmerman ME (2005) ANOVA-simultaneaus component analysis (ASCA): a new tool
#'  for analyzing designed \cr metabolomics data, Bioinformatics 21,13,3043
#'  DOI:/10.1093/bioinformatics/bti476
#'  \item Zwanenburg G, Hoefsloot HCJ, Westerhuis JA, Jansen JJ, Smilde AK
#'  (2011) ANOVA.Principal component analysis and ANOVA-simultaneaus component
#'  analysis: a comparison J. \cr Chemometrics 25:561-567 DOI:10.1002/cem.1400
#'  \item Tarazona S, Prado-Lopez S, Dopazo J, Ferrer A, Conesa A (2012) 
#'  Variable Selection for Multifactorial Genomic Data, Chemometrics and
#'  Intelligent Laboratory Systems, 110:113-122
#' }
#'
#' @name lmdme-class
#' @rdname lmdme-Class
#' @exportClass lmdme
setClass(Class="lmdme",
  representation=representation(
    design="data.frame",
    model="formula",
    modelDecomposition="list",
    residuals="list",
    coefficients="list",
    p.values="list",
    F.p.values="list",
    components="list",
    componentsType="character"),
  prototype=prototype(
    design=data.frame(),
    residuals=list(),
    coefficients=list(),
    p.values=list(),
    F.p.values=list(),
    modelDecomposition=list(),
    components=list(),
    componentsType=character()),
  validity=function(object){
    ## Check length of list of residuals, coefficients, pvalues, Fpvalues, models
    modelsLength<-c(length(object@residuals), length(object@coefficients), 
      length(object@p.values), length(object@F.p.values),
      length(object@modelDecomposition))
    if(any(modelsLength != modelsLength[1])) 
      stop("List type slots do not have the appropriate length")
    return(TRUE)
  }
)

#' \code{Show}, \code{Print} or \code{Summary} a lmdme object
#'
#' Generic Show/Print/Summary method for lmdme class output visualization.
#'
#' @param x lmdme class object.
#' @param object lmdme class object.
#' @param term character with the corresponding term to return. Default value 
#'  is NULL to return every decomposed term (if more than one is available).
#'
#' @return according to the call
#'  \item{print, show or summary:}{console output text with increasing detail of
#'  lmdme object.}
#'  \item{show or summary}{console output text of the lmdme object, plus a 
#'  data.frame with model decomposition summary data.}
#'
#' @seealso \code{\link{lmdme}}, \code{\link{coef}}, \code{\link{resid}}, 
#' \code{\link{fitted}}, \code{\link{modelDecomposition}},
#' \code{\link{components}}, \code{\link{componentsType}}
#'
#' @author Cristobal Fresno and Elmer A Fernandez
#'
#' @examples
#' {
#' data(stemHypoxia)
#' 
#' ##Just to make a balanced dataset in the Fisher sense (2 samples per 
#' ## time*oxygen levels)
#' design<-design[design$time %in% c(0.5, 1, 5) & design$oxygen %in% c(1,5,21),]
#' design$time<-as.factor(design$time)
#' design$oxygen<-as.factor(design$oxygen)
#' rownames(M)<-M[, 1]
#' 
#' ##Keeping appropriate samples only
#' M<-M[, colnames(M) %in% design$samplename] 
#' 
#' ##ANOVA decomposition
#' fit<-lmdme(model=~time+oxygen+time:oxygen, data=M, design=design)
#' }
#' \dontrun{ 
#'  #equivalent to call show(fit) 
#'  fit 
#'  print(fit)
#'  summary(fit) 
#' }
#'
#' @exportMethod print
#' @docType methods
#' @name print
#' @rdname lmdme-printshow
#' @usage \S4method{print}{lmdme}(x, term)
#' @aliases print,lmdme-method
setMethod(f="print", signature="lmdme", definition=function(x, term=NULL){
   show(x)
   ##If term is available the data of the corresponding term
   if(!missing(term)){
    cat("Residuals (head):\n")
    print(head(residuals(x, term=term)))
    cat("Coefficients (head):\n")
    print(head(coefficients(x, term=term)))
    cat("P-Values (head):\n")
    print(head(pvalues(x, term=term)))
  }else{
    ##All the terms of the model
    cat("Residuals (head):\n")
    print(lapply(residuals(x, term=term, drop=FALSE), head))
    cat("Coefficients (head):\n")
    print(lapply(coefficients(x, term=term, drop=FALSE), head))
    cat("P-Values (head):\n")
    print(lapply(pvalues(x, term=term, drop=FALSE), head))
  }
})
#' @exportMethod show
#' @name show
#' @rdname lmdme-printshow
#' @inheritParams print
#' @usage \S4method{show}{lmdme}(object)
#' @aliases show,lmdme-method
setMethod(f="show", signature="lmdme", definition=function(object){
    ##Basic information of lmdme class
    cat("lmdme object: \n")
    cat("Data dimension: ", nrow(object@residuals[[1]])," x ", 
      ncol(object@residuals[[1]]))
    cat("\nDesign (head): \n")
    print(head(object@design))
    cat("\nModel:")
    print(object@model)
    cat("Model decomposition: \n")
    deflaction<-data.frame(Step=1:length(object@modelDecomposition), 
      Names=names(object@modelDecomposition), Formula=c("~ 1", 
      paste("~ -1 + ", names(object@modelDecomposition)[-1], sep="")),
      CoefCols=as.numeric(lapply(object@coefficients, ncol)))
    print(deflaction)
   
    ##Just to keep de information of how the deflaction process was carried out
    return(invisible(deflaction))
})
#'
#' @exportMethod summary 
#' @name summary
#' @rdname lmdme-printshow
#' @inheritParams show
#' @usage \S4method{summary}{lmdme}(object)
#' @aliases summary,lmdme-method
setMethod(f="summary", signature="lmdme", definition=function(object){
  return(show(object))
})

#' \code{p.adjust} of p-values for Multiple Test Comparison Corrections
#'
#' Given a set of p-values, returns adjusted p-values using one of several
#' methods.
#' 
#' @param p numeric vector of p-values as in stats::p.adjust or lmdme class
#' object.
#' @param method correction method available in \code{\link{p.adjust.methods}}.
#' @param term character with the corresponding term to return.
#' @param ... other arguments.
#' @param drop should try to drop the list structure if length==1? Default value
#' is TRUE 
#'
#' @return according to the call, one of the following objects can be returned
#' \item{numeric}{vector of adjusted p-values.}
#' \item{matrix}{for lmdme object If term!=NULL, the corresponding character is
#'  looked up within the list of p.values returning the associated matrix of G
#'  rows (individuals) x k columns (levels of the corresponding model term) with
#'  the adjusted p-values.}
#'  
#' @seealso \code{\link{p.adjust}}, \code{\link{p.adjust.methods}}
#'
#' @author Cristobal Fresno and Elmer A Fernandez
#' 
#' @examples
#' {
#' data(stemHypoxia)
#' 
#' ##Just to make a balanced dataset in the Fisher sense (2 samples per 
#' ## time*oxygen levels)
#' design<-design[design$time %in% c(0.5, 1, 5) & design$oxygen %in% c(1,5,21),]
#' design$time<-as.factor(design$time)
#' design$oxygen<-as.factor(design$oxygen)
#' rownames(M)<-M[, 1]
#' 
#' ##Keeping appropriate samples only
#' M<-M[, colnames(M) %in% design$samplename] 
#' 
#' ##ANOVA decomposition
#' fit<-lmdme(model=~time+oxygen+time:oxygen, data=M, design=design)
#' 
#' ##Adjust p-values only on the interaction p.values using false discovery rate
#' ## method
#' pInteraction<-p.values(fit, term="time:oxygen") 
#' FDRInteraction<-p.adjust(fit, term="time:oxygen", method="fdr")
#' corrected<-sum(pInteraction < 0.05) - sum(FDRInteraction < 0.05)
#' }
#'
#' @exportMethod p.adjust
#' @docType methods
#' @name p.adjust
#' @rdname lmdme-padjust
#' @aliases p.adjust-methods
setGeneric(name="p.adjust", def=function(p, ...){standardGeneric("p.adjust")})
#'
#' @exportMethod p.adjust
#' @name p.adjust
#' @rdname lmdme-padjust
#' @inheritParams p.adjust
#' @aliases p.adjust,ANY-method
setMethod(f="p.adjust", signature="ANY", definition=stats::p.adjust)
#'
#' @exportMethod p.adjust
#' @name lmdme-padjust
#' @rdname lmdme-padjust
#' @inheritParams p.adjust
#' @usage \S4method{p.adjust}{lmdme}(p, term=NULL, method=p.adjust.methods, drop=TRUE)
#' @aliases p.adjust,lmdme-method
setMethod(f="p.adjust", signature="lmdme", definition=function(p, term=NULL,
  method=p.adjust.methods, drop=TRUE){
  out<-lapply(p.values(p, term, drop=FALSE), function(x){
    apply(x, MARGIN=2, FUN=p.adjust, method=method)
  })

  ##Check for drop parameter
  if(drop & length(out)==1){
    out<-out[[1]]
  }

  return(out)
})

#' \code{decomposition} of lmdme object
#' 
#' This function calculates the decomposition of variance or covariance
#' structure using Principal Component Analysis (PCA) or Partial Least
#' Squared Regression (PLSR), on the ANOVA decomposed lmdme object. In this
#' context, in a two factor experimental design with interaction, the linear
#' model of the i-th observation (gene) can be written: 
#' \cr \eqn{X=\mu+X_{A}+X_{B}+X_{AB}+\epsilon} \cr 
#' where \itemize{ 
#'   \item X stands for the observed value.
#'   \item the intercept \eqn{\mu}.
#'   \item \eqn{X_{A}}, \eqn{X_{B}} and \eqn{X_{AB}} are the first, second and
#'    interaction coefficients respectively.
#'   \item The error term \eqn{\epsilon ~ N(0,\sigma^2)}.
#' } 
#' The model is iteratively decomposed in a step by step fashion, decomposing 
#' one term each time by calling \code{\link{lmdme}} constructor: 
#' \enumerate{ 
#'   \item Step 1: \eqn{X=\mu+E_{1}} 
#'   \item Step 2: \eqn{E_{1}=X_{A}+E_{2}} 
#'   \item Step 3: \eqn{E_{2}=X_{B}+E_{3}} 
#'   \item Step 4: \eqn{E_{3}=X_{AB}+E_{4}}
#' } 
#' Then, if we apply PCA on the i-th step using \eqn{E_{i-1}} matrix it is
#' known as \emph{APCA} but if applied on the coefficients \eqn{X_{i}} it is
#' called \emph{ASCA}. The same decomposition schema can also be used with
#' PLSR.
#'
#' @param object lmdme class object.
#' @param decomposition character to indicate the decomposition to be carried
#'  out, i.e., \emph{"pca"} or \emph{"plsr"}. Default value is "pca".
#' @param term character specifying the model term to perform the decomposition
#'  (e.g. "time" or "time:concentration" for interaction term). If the term is
#'  not specified (i.e. missing) it performs the analysis over all the model
#'  terms. 
#' @param subset subset of individuals (rows) to be included in the analysis.
#'  By default all the individuals are included.
#' @param type character to indicate on which regression matrix ("coefficient"
#'  or "residual") the decomposition will be performed. The intercept term is
#'  not included in the results, as it can be directly analyzed with the
#'  original M data.frame. Default value is "coefficient" a.k.a. ASCA. Note
#'  that "residual" performs PCA or PLS on the i-th residual
#'  \eqn{E_{i-1}=X_{i}+E_{i}} and not the residuals of the i-th model
#'  \eqn{E_{i}}.
#' @param scale character "row", "column" or "none" to indicate if the matrix
#'  should be scaled by the row, column or not  respectively. Default value
#'  is "none".
#' @param Omatrix the output matrix for PLSR only. If the parameter is missing,
#'  the output matrix  will be an identity matrix for the ASCA. Otherwise, is
#'  the design matrix corresponding to the specified term for APCA.
#' @param ... additional parameters for \code{\link{prcomp}} or
#'  \code{\link{plsr}} functions, according to the decomposition call.
#'
#' @return Internal update of the "components" slot of the lmdme object, which
#'  is a list of \code{\link{prcomp}} or a list of mvr (\code{\link{plsr}})
#'  objects using the given term parameter. If missing(term), the length of the
#'  list equals the number of decomposed models minus the Intercept term for
#'  coefficients or the length of decomposed models for residual decomposition. 
#'
#' @seealso \code{\link{prcomp}}, \code{\link{plsr}}
#'
#' @author Cristobal Fresno and Elmer A Fernandez
#'
#' @references 
#' \enumerate{
#'  \item Smilde AK, Jansen JJ, Hoefsloot HCJ, Lamer RAN, Van der Greef
#'  J, Timmerman ME (2005) ANOVA-simultaneous component analysis (ASCA): a
#'  new tool for analyzing designed meta-bolomics data, Bioinformatics
#'  21,13,3043 DOI:/10.1093/bioinformatics/bti476
#'  \item Zwanenburg G, Hoefsloot HCJ, Westerhuis JA, Jansen JJ, Smilde AK
#'  (2011) ANOVA Principal component analysis and ANOVA-simultaneous
#'  component analysis: a comparison J. Chemometrics 25:561-567
#'  DOI:10.1002/cem.1400
#'  \item Cristobal Fresno, Monica G. Balzarini, Elmer A. Fernandez (2014)
#'  lmdme: Linear Models on Designed Multivariate Experiments in R,
#'  Journal of Statistical Software, 56(7), 1-16.
#'  http://www.jstatsoft.org/v56/i07/.
#' }
#'
#' @examples
#' {
#' data(stemHypoxia)
#' 
#' ##Just to make a balanced dataset in the Fisher sense (2 samples per 
#' ## time*oxygen levels) 
#' design<-design[design$time %in% c(0.5,1,5) & design$oxygen %in% c(1,5,21), ]
#' design$time<-as.factor(design$time)
#' design$oxygen<-as.factor(design$oxygen)
#' rownames(M)<-M[, 1]
#' 
#' #Keeping appropriate samples only
#' M<-M[, colnames(M) %in% design$samplename] 
#' 
#' ##ANOVA decomposition
#' fit<-lmdme(model=~time+oxygen+time:oxygen, data=M, design=design)
#' 
#' ##Just a copy of the same fit object and to perform analysis on those
#' ##subjects/genes where at least one interaction coefficient is statistically
#' ##different from zero (F-test on the coefficients).
#' asca<-fit
#' apca<-fit
#' id<-F.p.values(fit, term="time:oxygen")<0.001
#' 
#' ##ASCA and APCA decomposition for every available term.
#' decomposition(asca, decomposition="pca", subset=id, scale="row")
#' decomposition(apca, decomposition="pca", subset=id, scale="row",
#'   type="residual")
#' 
#' ##Let's get the components for asca/apca decomposed objects
#' asca<-components(asca) 
#' apca<-components(apca) 
#' 
#' ##Now let's try the PLSR decomposition for residuals and coefficients
#' plsr.residuals<-fit
#' plsr.coefficients<-fit
#' decomposition(plsr.coefficients, decomposition="plsr", subset=id,
#'   scale="row")
#' decomposition(plsr.residuals, decomposition="plsr", subset=id, scale="row",
#'   type="residual")
#' 
#' ##Obtain the coefficients for decomposed plsr objects
#' ##(coefficients/residuals)
#' plsr.coefficients<-components(plsr.coefficients) 
#' plsr.residuals <- components(plsr.residuals) 
#' }
#' 
#' @exportMethod decomposition
#' @docType methods
#' @name decomposition
#' @rdname lmdme-decomposition
#' @aliases decomposition-methods
setGeneric(name="decomposition", def = function(object,
  decomposition=c("pca","plsr"), term=NULL,
  subset=1:nrow(object@residuals[[1]]), type = c("coefficient", "residual"),
  scale=c("none","row","column"), Omatrix, ...){
  standardGeneric("decomposition")
})
#'
#' @name decomposition
#' @rdname lmdme-decomposition
#' @inheritParams decomposition
#' @aliases decomposition,lmdme-method
setMethod(f="decomposition", signature = "lmdme", definition = function(object,
  decomposition=c("pca","plsr"), term=NULL,
  subset=1:nrow(object@residuals[[1]]), type=c("coefficient", "residual"),
  scale=c("none","row","column"), Omatrix, ...){
  ##Obtain object name for future update
  nameObject<-deparse(substitute(object)) 
  
  ##Check parameters
  stopifnot(scale[1] %in% c("none","row","column"))
  stopifnot(type[1] %in% c("coefficient", "residual"))
  stopifnot(decomposition[1] %in% c("pca","plsr"))
  if(missing(Omatrix)){
    Omatrix<-NULL
  }
  
  #No sense to decompose the intercept
  if(!is.null(term)){
    if(term == "(Intercept)"){
      stop(paste("Error: does not make sense to decompose the intercept", 
      "coefficients/residuals. Use the centered original data object", sep=""))
    }
    else{
       if(!any(term %in% names(object@modelDecomposition))){
        stop("ERROR: ", term, " not in model: ", object@model)
       }
    }
  }

  ##Over which matrix is to be the carry the escalation and calculate it
  data<-switch(type[1], 
    coefficient=coefficients(object, term, drop=FALSE), 
    residual={
      ##Get the names of the term if missing
      if(is.null(term)){
        term<-names(object@modelDecomposition)[-1]
      }
 
      ##Get the residual of the previous model
      datum<-as.list(term)
      names(datum)<-term
      lapply(datum, function(x){
        index<-which(names(object@modelDecomposition) == x)

        ##Get the previous residual
        aux<-object@residuals[[index-1]]
        colnames(aux)<-colnames(object@residuals[[index]])
        aux
      })
    }
  )
  
  ##Remove the intercept term if available
  if("(Intercept)" %in% names(data) & type[1] == "coefficient"){
    data<-data[-1]
  } 

  ##Scale if required
  data<-lapply(data, function(datum){
    switch(scale[1], 
      none=datum[subset,], 
      row=t(scale(t(datum[subset,]))), 
      column=scale(datum[subset,])
    )
  })

  ##decomposition calculation
  index<-as.list(1:length(data))
  names(index)<-names(data)
  object@components<-lapply(index, function(datum){
    switch(decomposition[1], 
      pca=prcomp(data[[datum]], ...),
      plsr={
        data.pls<-list(X=t(data[[datum]]))
      
        ##Check for Omatrix presence
        if(is.null(Omatrix)){
          Omatrix<-switch(type[1], 
            coefficient=diag(1, nrow(data.pls$X)),
            residual=model.matrix(
              object@modelDecomposition[[names(data)[datum]]], object@design)
          )
          rownames(Omatrix)<-switch(type[1],
            coefficient=rownames(data.pls$X), 
            residual=NULL
          )    
          rownames(data.pls$X)<-switch(type[1],
            coefficient=rownames(data.pls$X),
            residual=NULL
          )
        }#is.null(Omatrix)   
      
        data.pls$Y<-Omatrix
        plsr(formula=Y~X, data=data.pls, ...)
      }#from plsr
    )#from decomposition 
  })#from lapply

  ##Update lmdme object
  object@componentsType<-c(decomposition=decomposition[1],
    type=type[1], scale=scale[1])
  assign(nameObject, object, envir=parent.frame())

  return(invisible(NULL))
})

#' Plot a \code{screeplot} of a PCA decomposed lmdme object
#' 
#' Screeplot on each decomposed "pca" model present in lmdme components slot.
#'
#' @param x lmdme class object.
#' @param independent logical indicating whether the screeplots should be
#'  plotted together. Default value is FALSE.
#' @param col which color to use for each decomposed model. Default value
#'  seq(along= components(x)).
#' @param npcs integer with the number of components to plot. By default all
#'  present components are plotted.
#' @param term character with the corresponding term/s for biploting. Default
#'  value is NULL in order to obtain every available biplot/s.
#' @param mfcol numeric vector for par layout. If missing, mfcol=c(1,2) will be
#'  used if more than one biplot is available. Use  mfcol==NULL to override par
#'  call inside biplot function.
#' @param ... additional parameters for screeplot or plot/lines according to
#'  independent FALSE or TRUE respectively.
#'
#' @return plotted screeplot/s of the components slot if PCA decomposition was
#'  applied.
#'
#' @seealso stats::screeplot
#'
#' @author Cristobal Fresno and Elmer A Fernandez
#'
#' @examples
#' {
#' data(stemHypoxia)
#' 
#' ##Just to make a balanced dataset in the Fisher sense (2 samples per 
#' ## time*oxygen levels) 
#' design<-design[design$time %in% c(0.5,1,5) & design$oxygen %in% c(1,5,21), ]
#' design$time <-as.factor(design$time)
#' design$oxygen<-as.factor(design$oxygen)
#' rownames(M)<-M[, 1]
#' 
#' #Keeping appropriate samples only
#' M<-M[, colnames(M) %in% design$samplename] 
#' 
#' ##ANOVA decomposition
#' fit<-lmdme(model=~time+oxygen+time:oxygen, data=M, design=design)
#'
#' ##ASCA for all the available terms, on those subjects/genes where at least
#' ##one interaction coefficient is statistically different from zero (F-test
#' ##on the coefficients).
#' id<-F.p.values(fit,term="time:oxygen")<0.001
#' decomposition(fit, decomposition="pca", scale="row", subset=id) 
#'
#' \dontrun{
#' par(mfrow=c(2,2))
#'
#' ##Does not call par inside
#' screeplot(fit,mfcol=NULL)
#'
#' ##Just the term of interest
#' screeplot(fit,term="time")
#'
#' ##In separate graphics
#' screeplot(fit,term=c("time","oxygen"),mfcol=c(1,1))
#'
#' ##All term in the same graphic device
#' screeplot(fit,mfcol=c(1,3))
#'
#' ##All in the same graphic
#' screeplot(fit,independent=FALSE)
#' }
#' }
#' 
#' @exportMethod screeplot
#' @docType methods
#' @name screeplot
#' @rdname lmdme-screeplot
#' @usage \S4method{screeplot}{lmdme}(x, independent=TRUE, col=seq(along=components(x)), npcs, term=NULL, mfcol, ...)
#' @aliases screeplot,lmdme-method
setMethod(f="screeplot", signature="lmdme", definition=function(x,
  independent=TRUE, col=seq(along=components(x)), npcs, term=NULL, mfcol, ...){
  ##Check is componentType is available
  if(length(componentsType(x))==0){
    stop("No available PCA decomposed model. Please run decomposition(x)")
  }
  if(componentsType(x)["decomposition"]!="pca"){
    stop(paste("No available PCA decomposed model. Please run",
      "decomposition(x,decomposition=\"pca\")"))
  }

  ##Get the components to use
  component<-components(x, term=term,drop=FALSE)

  ##Check mfcol to adjust par parameter and create the first biplot
  if(missing(mfcol)){
    if(length(component)==1){
      mfcol<-c(1,1)
    } 
    else{ 
      mfcol<-c(1,2)
    }
  }  
  graphicsPerPar<-prod(mfcol)

  ##Should the screeplot be plotted independent
  if(independent){
    ##Check npcs
    if(missing(npcs)){npcs<-NULL}

    invisible(sapply(seq(along=component),function(pca){  
      ##Tunning the graphic device if required
      if(!is.null(mfcol) & ((pca-1) %% (graphicsPerPar))==0){
        X11()
        par(mfcol=mfcol)
      }

      ##Check npcs
      if(is.null(npcs)){
        screeplot(component[[pca]], main=names(component)[[pca]], ...,
          col=col[pca])
      }else{
        screeplot(component[[pca]], main=names(component)[[pca]], npcs=npcs,
          col=col[pca], ...)
      }
   }))#sapply(seq(along=component)
  }else{
      ##Not independent screeplots (same device)
      variance<-lapply(component, function(pca){pca$sdev^2/sum(pca$sdev^2)})
      maxVariance<-max(unlist(lapply(variance,max)))
      maxComp<-ifelse(!missing(npcs), npcs, max(unlist(lapply(variance,
        length)))) 

      ##First screeplot
      plot(x=seq(along=variance[[1]]), y=variance[[1]], type="b",
        ylab="Variance", xlab="Component", xlim=c(1, maxComp), ylim=c(0,
        maxVariance), col=col[1], ...)

      ##The rest if available
      invisible(sapply(seq(along=variance)[-1], function(pca, variance){
        lines(x=seq(along=variance[[pca]]), y=variance[[pca]],
        type="b", col=col[pca], ...)
      },variance))
      legend("topright", legend=names(component), lty="solid", 
        box.col="transparent", col=col)
  }
})  

#' \code{permutation} of the specified lmdme object
#'
#' Produces the specified lmdme plus the required permuted objects (sampling the
#' columns), using the same parameters to fit the additional models.
#' 
#' @param model formula object to carry out the decomposition.
#' @param data data.frame with individuals (rows) and samples/conditions
#' (columns)
#' @param design data.frame with the design of the experiment, (rows) 
#'  samples/conditions as in data columns and as many columns to indicate the
#'  factors present in each sample.
#' @param Bayes Should limma estimate empirical Bayes statistics, i.e., 
#'  moderated t-statistics? Default value is FALSE.
#' @param verbose Should the process progress be printed? Default value is
#' FALSE.
#' @param NPermutations number of permutations to be calculated. Default value 
#'  is 100.
#' @param nCpus number of cores to be used. Default value is 1, i.e. sequential
#'  calculation.
#' @param ... Additional parameters for the \code{\link{lmFit}} function.
#'
#' @return 
#'  \item{list}{contains the original lmdme object plus the required amount 
#'  of permuted versions.} 
#'
#' @seealso \code{\link{lmdme}}
#'
#' @author Cristobal Fresno and Elmer A Fernandez
#'
#' @examples
#' {
#' data(stemHypoxia)
#' 
#' ##Just to make a balanced dataset in the Fisher sense (2 samples per 
#' ## time*oxygen levels)
#' design<-design[design$time %in% c(0.5, 1, 5) & design$oxygen %in% c(1,5,21),]
#' design$time<-as.factor(design$time)
#' design$oxygen<-as.factor(design$oxygen)
#' rownames(M)<-M[, 1]
#' 
#' ##Keeping appropriate samples only
#' M<-M[, colnames(M) %in% design$samplename] 
#' 
#' ##Just to test if it works. In a real scenario, use NPermutations >= 100 if
#' ##the conditions (columns) of M allow it. Verbose parameter is FALSE by
#' ##default
#' permuted<-permutation(model=~time*oxygen, data=M, design=design,
#' NPermutations=2, nCpus=3)
#' }
#'
#' @exportMethod permutation
#' @docType methods
#' @name permutation
#' @rdname lmdme-permutation
#' @aliases permutation-methods
setGeneric(name="permutation", def=function(model, data, design, Bayes=FALSE,
  verbose=FALSE, NPermutations=100, nCpus=1, ...){
  standardGeneric("permutation")
})
#'
#' @name permutation
#' @rdname lmdme-permutation
#' @inheritParams permutation
#' @usage \S4method{permutation}{formula,data.frame,data.frame}(model,data,design,Bayes=FALSE,verbose=FALSE,NPermutations=100,nCpus=1,...)
#' @aliases permutation,formula,data.frame,data.frame-method
setMethod(f="permutation", signature=signature(model="formula",
  data="data.frame", design="data.frame"), definition=function(model, data,
  design, Bayes=FALSE, verbose=FALSE, NPermutations=100, nCpus=1, ...){
  ##Generate the permuted samples: original structure + NPermutations
  permutations<-cbind(1:ncol(data),
    sapply(1:NPermutations, function(iteration, indexes){sample(indexes)},
    indexes=1:ncol(data)))
  
  ##Auxiliary functions, print if verbose==TRUE
  if(verbose){
    printnow<-function(...){ cat(...);flush.console()}
  }else{
    printnow<-function(...){invisible (NULL)}
  }

  ##Auxiliary functions for parallel processing if available
  if(require(parallel)){
    parlapply<-mclapply
    ##Get the cpus data for parallel lmdme calculation
    ##Check if windows platform
    if(.Platform$OS.type == "windows"){
      nCpus<-1
    }else{
      ncores<-detectCores()
      printnow("using", nCpus, "core/s from", ncores, "available/s\n")
    }
  }
  else{
    ##parallel not installed so, use the well known lapply
    parlapply<-function(X, FUN, ..., mc.cores){lapply(X, FUN, ...)}
  }

  ##Get the cpus data for parallel lmdme calculation
  ##Check if windows platform
  if(.Platform$OS.type == "windows"){
    nCpus<-1
  }else{
      ncores<-detectCores()
      printnow("using", nCpus, "core/s from", ncores, "available/s\n")
  }

  ##Just to make the index of the permutations
  permutedModels<-as.list(1:ncol(permutations))
  names(permutedModels)<-c("Original", as.character(1:NPermutations))

  ##Start calculating the permutations
  time <- Sys.time()
  printnow("Start Time:", as.character(time), "\n")
  permutedModels<-parlapply(permutedModels, function(index){
    printnow("Running Model: ", index, "\n")
    return(lmdme(model=model, data=data[, permutations[,index]], design=design,
      Bayes=Bayes, verbose=verbose, ...))}, mc.cores = nCpus)
  ##End calculations
  timeEnd <- Sys.time()
  printnow("End Time", as.character(timeEnd), "\n")
  timedifference<-timeEnd-time
  printnow("Time difference of ", format(unclass(timedifference),
    digits=getOption("digits")), " ", attr(timedifference , "units"), "\n")
  return(permutedModels)
})

\documentclass[article,shortnames, nojss]{jss}
\usepackage{amsmath}
\usepackage{afterpage}
\usepackage{subfigure}
\usepackage[figuresright]{rotating} 
% \VignetteIndexEntry{lmdme: linear model framework for PCA/PLS analysis of ANOVA decomposition on Designed Multivariate Experiments in R }
% \VignetteDepends{stemHypoxia, limma, pls}
% \VignetteKeyword{ANOVA decomposition}
% \VignetteKeyword{linear model}
% \VignetteKeyword{PCA}
% \VignetteKeyword{PLS}

\author{Crist\'{o}bal Fresno\\Universidad Cat\'{o}lica de C\'{o}rdoba \And 
        M\'{o}nica G Balzarini\\Universidad Nacional de C\'{o}rdoba \AND 
        Elmer A Fern\'{a}ndez\\Universidad Cat\'{o}lica de C\'{o}rdoba}

\title{\pkg{lmdme}: Linear Models on Designed Multivariate Experiments in \proglang{R}}

%% for pretty printing and a nice hypersummary also set:
\Plainauthor{Crist\'{o}bal Fresno, M\'{o}nica G Balzarini, Elmer A Fern\'{a}ndez} %% comma-separated
\Plaintitle{lmdme: Linear Models on Designed Multivariate Experiments in R} %% without formatting
\Shorttitle{\pkg{lmdme}: Linear Models on Designed Multivariate Experiments in \proglang{R}} %% a short title (if necessary)

%% an abstract and keywords
\Abstract{
  This introduction to linear model on designed multivariate experiments of the \proglang{R} package \pkg{lmdme} is a (slightly) modified version of \citet{lmdmeJSS}, published in the \emph{Journal of Statistical Software}.\\
  The \pkg{lmdme} package \citep{lmdme} decomposes analysis of variance (ANOVA) through linear models on designed multivariate experiments, allowing ANOVA-principal component analysis (APCA) and ANOVA-simultaneous component analysis (ASCA) in \proglang{R} \citep{R}. It also extends both methods with the application of partial least squares (PLS) through the specification of a desired output matrix. The package is freely available on the Bioconductor website \citep{Bioconductor}, licensed under GNU general public license.\\
  ANOVA decomposition methods for designed multivariate experiments are becoming popular in ``omics'' experiments (transcriptomics, metabolomics, etc.), where measurements are performed according to a predefined experimental design \citep{Smilde}, with several experimental factors or including subject-specific clinical covariates, such as those present in current clinical genomic studies. ANOVA-PCA and ASCA are well-suited methods for studying interaction patterns on multidimensional datasets. However, current \proglang{R} implementation of APCA is only available for \emph{Spectra} data in \pkg{ChemoSpec} package \citep{ChemoSpec}, whereas ASCA \citep{Nueda} is based on average calculations on the indices of up to three design matrices. Thus, no statistical inference on estimated effects is provided. Moreover, ASCA is not available in \proglang{R} package format.\\
  Here, we present an \proglang{R} implementation for ANOVA decomposition with PCA/PLS analysis that allows the user to specify (through a flexible \code{formula} interface), almost any linear model with the associated inference on the estimated effects, as well as to display functions to explore results both of PCA and PLS. We describe the model, its implementation and one high-throughput \emph{microarray} example applied to interaction pattern analysis.
}
\Keywords{linear model, ANOVA decomposition, PCA, PLS, designed experiments, \proglang{R}}
\Plainkeywords{linear model, ANOVA decomposition, PCA, PLS, designed experiments, R} %% without formatting
%% at least one keyword must be supplied

%% publication information
%% NOTE: Typically, this can be left commented and will be filled out by the technical editor
%% \Volume{50}
%% \Issue{9}
%% \Month{June}
%% \Year{2012}
%% \Submitdate{2012-06-04}
%% \Acceptdate{2012-06-04}

%% The address of (at least) one author should be given
%% in the following format:
\Address{
  Crist\'{o}bal Fresno \& Elmer A Fern\'{a}ndez\\
  Bioscience Data Mining Group\\
  Faculty of Engineering\\
  Universidad Cat\'{o}lica de C\'{o}rdoba\\
  X5016DHK C\'{o}rdoba, Argentina\\
  E-mail: \email{cfresno@bdmg.com.ar, efernandez@bdmg.com.ar}\\
  URL: \url{http://www.bdmg.com.ar/}\\
  $~$\\
  M\'{o}nica G Balzarini\\
  Biometry Department\\
  Faculty of Agronomy\\
  Universidad Nacional de C\'{o}rdoba\\
  X5000JVP C\'{o}rdoba, Argentina\\
  E-mail: \email{mbalzari@gmail.com}\\
  URL: \url{http://www.infostat.com.ar/}
}

%% It is also possible to add a telephone and fax number
%% before the e-mail in the following format:
%% Telephone: +43/512/507-7103
%% Fax: +43/512/507-2851

%% for those who use Sweave please include the following line (with % symbols):
%% need no \usepackage{Sweave.sty}

%% end of declarations %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{document}
% \SweaveOpts{concordance=FALSE}

%% include your article here, just as usual
%% Note that you should use the \pkg{}, \proglang{} and \code{} commands.

%%\section[About Java]{About \proglang{Java}}
%% Note: If there is markup in \(sub)section, then it has to be escape as above.
\newpage

\section{Introduction}
Current ``omics'' experiments (proteomics, transcriptomics, metabolomics or genomics) are multivariate in nature. Modern technology allows us to explore the whole genome or a big subset of the proteome, where each gene/protein is in essence a variable explored to elucidate its relationship with an outcome. In addition, these experiments are including an increasing number of experimental factors (time, dose, etc.) from design or subject-specific information, such as age, gender and linage, and are available for analysis. Hence, to decipher experimental design or subject-specific patterns, some multivariate approaches should be applied, with principal component analysis (PCA) and partial least squares regression (PLS) being the most common. However, it is known that working with raw data might mask information of interest. Therefore, analysis of variance (ANOVA)-based decomposition is becoming popular to split variability sources before applying such multivariate approaches. 
Seminal works on genomics were that of \cite{DeHaan} on ANOVA-PCA (APCA) and of \cite{Smilde} on ANOVA-SCA (ASCA) models. However, to the best of our knowledge \proglang{R} implementation of APCA is only available for \emph{Spectra} data, \pkg{ChemoSpec} \proglang{R} package by \cite{ChemoSpec}. Regarding ASCA, as there is no \proglang{R} package for this model, it can only be used by uploading script-function files resulting from a MATLAB code translation \citep{Nueda}. In addition, ASCA only accepts up to three design matrices, which limits its use and makes it difficult. Moreover, coefficient estimations are based on average calculations using binary design matrices, without any statistical inference over them.\\
Here, we provide a flexible linear model-based decomposition framework. Almost any model can be specified, according to the experimental design, by means of a flexible \code{formula} interface. Because coefficient estimation is carried out by means of maximum likelihood, statistical significance is naturally given. The framework also provides both capacity to perform PCA and PLS analysis on appropriate ANOVA decomposition results, as well as graphical representations. The implementation is well-suited for direct analysis of gene expression matrices (variables on rows) from high-throughput data such as \emph{microarray} or \emph{RNA-seq} experiments. Below we provide an examples to introduce the user to the package applications, through the exploration of interaction patterns on a microarray experiment.

\section{The model}
\label{sec:model}
A detailed explanation of ANOVA decomposition and multivariate analysis can be found in \cite{Smilde} and \cite{Zwanenburg}. Briefly and without the loss of generality, let us assume a \emph{microarray} experiment where the expression of $(G_{1},~G_{2}, ~\ldots~,~G_{g})$ genes are arrayed in a chip. In this context, let us consider an experimental design with two main factors: $A$, with $a$ levels $(A_{1},~A_{2},~\ldots~,~A_{i},~\ldots~,~A_{a})$ and $B$, with $b$ levels $(B_{1},~B_{2},~\ldots~,~B_{j},~\ldots~,~B_{b})$, with replicates $R_{1},~R_{2},~\ldots~,~R_{k},~\ldots~,~R_{r}$ for each $A \times B$ combination levels. After preprocessing steps are performed as described in \citep{Smyth}, each chip is represented by a column vector of gene expression measurements of $g \times 1$.  Then, the whole experimental data is arranged into a $g \times n$ expression matrix ($X$), where $n = a \times b \times r$. In this data scheme, single gene measurements across the different treatment combinations ($A_{i} \times B_{j}$) are presented in a row on the $X$ matrix, as depicted in Figure~\ref{fig:microarray}. An equivalent $X$ matrix structure needs to be obtained for \emph{2D-DIGE} or \emph{RNA-seq} experiments and so forth.\\
\begin{sidewaysfigure}
    \centering
    \includegraphics[width=\textwidth]{microarray} 
    \caption{Data representation of microarray gene expression. A) Genes are spotted on the chip. Then, expression levels for each combination of treatment factor levels $A_{i}B_{j}$ and their replicates $R_{k}$ can be measured on the chips, yielding a total of $n=a \times b \times r$ microarrays. B) Gene expression of each chip (microarray) is then interpreted as a column vector of expression levels. C) Then, these column vectors will be combined by columns producing the experiment gene expression matrix $X$. Expression measurements under all treatment combinations for a gene are represented by the $X$ matrix rows. Thus, measurements on a row are subjected to the ANOVA model of (\ref{eq:anova}).}    
    \label{fig:microarray}
\end{sidewaysfigure}

Regardless of data generation, the ANOVA model for each gene (row) in $X$ can be expressed as (\ref{eq:anova}):
\begin{equation}
 x_{ijk}=\mu+\alpha_{i}+\beta_{j}+\alpha_{i}\times\beta_{j}+\varepsilon_{ijk}
\label{eq:anova}  
\end{equation}
Where $x_{ijk}$ is the measured expression for ``some'' gene, at combination ``$ij$'' of factors $A$ and $B$ for the $k$ replicate; $\mu$ is the overall mean; $\alpha, \beta$ and $\alpha \times \beta$ are the main and interaction effects respectively; and the error term $\varepsilon_{ijk} \sim N(0,\sigma^{2})$. In addition, (\ref{eq:anova}) can also be expressed in matrix form for all genes into (\ref{eq:matrix}):
\begin{equation}
  X=X_{\mu}+ X_{\alpha}+X_{\beta}+X_{\alpha \beta}+E=\sum_{l\in{\{\mu,\alpha, \beta, \alpha \beta\}}}X_{l}+E
\label{eq:matrix}  
\end{equation}
Where $X_{l}$, $E$ matrices are of dimension $g \times n$ and contain the level means of the corresponding $l-th$ term and the random error respectively. However, in the context of linear models $X_{l}$ can also be written as a linear combination of two matrix multiplications in the form of (\ref{eq:linearmodel}):
\begin{multline}
   X=\sum_{l\in \{\mu,\alpha, \beta, \alpha \beta\}}X_{l}+E=\sum_{l\in \{\mu, \alpha, \beta, \alpha \beta\}}B_{l}Z_{l}^{T}+E=B_{\mu}Z_{\mu}^{T}+\ldots+B_{\alpha \beta}Z_{\alpha \beta}^{T}+E=\\
 \mu 1^{\top} +B_{\alpha}Z_{\alpha}^{T}+\ldots+B_{\alpha \beta}Z_{\alpha \beta}^{T}+E
\label{eq:linearmodel}  
\end{multline}
Where $B_{l}$ and $Z_{l}$ are referenced in the literature as \emph{coefficient} and \emph{model} matrices of dimensions $g \times m_{(l)}$ and $ n \times m_{(l)}$, respectively, and $m_{(l)}$ is the number of levels of factor $l$. The first term is usually called \emph{intercept}, with $B_{\mu}=\mathbf{\mu}$ and $Z_{\mu}=\mathbf{1}$ being of dimension $g \times 1$ and $n \times 1$, respectively. In this example, all $Z_{l}$ are binary matrices, identifying whether a measurement belongs (``1'') or not (``0'') to the corresponding factor.\\
In the implementations provided by \cite{Smilde} and \cite{Nueda}, the estimation of the coefficient matrices is based on calculations of \emph{averages} using the design matrix (up to three design matrices $Z_{\alpha, \beta, \alpha \beta}$), to identify the average samples. In theory, these authors fully decompose the original matrix as shown in (\ref{eq:anova}). On the contrary, in this package the model coefficients are estimated, iteratively, by the \emph{maximum likelihood} approach, using the \code{lmFit} function provided by \pkg{limma} package \citep{limma}. Consequently, three desirable features are also incorporated: 
\begin{enumerate}
 \item \emph{Flexible} \code{formula} \emph{interface} to specify any potential model. The user only needs to provide: i) The gene expression \code{matrix} ($X$), ii) The experimental \code{data.frame} (\code{design}) with treatment structure, and iii) The model in a \code{formula} style, just as in an ordinary \code{lm} \proglang{R} function. Internal \code{model.matrix} call, will automatically build the appropriate $Z$ matrices, overcoming the constraint on factorial design size, and tedious model matrix definitions.
 \item \emph{Hypothesis tests} on coefficient $B_{l}$ matrices. A $T$~test is automatically carried out for the $s-th$ gene model, to test whether or not the $o-th$ coefficient is equal to zero, i.e., $H_{0}:b_{so}=0$ vs $H_{1}:b_{so} \neq 0$. In addition, an $F$~test is performed to simultaneously determine whether or not all $b_{so}$ are equal to zero.
 \item \emph{Empirical Bayes correction} can also be achieved through the \code{eBayes} \pkg{limma} function. It uses an empirical Bayes method to shrink the row/gene-wise sample variances towards a common value and to augment the degrees of freedom for the individual variances \citep{Smyth}.
\end{enumerate}
By contrast, \cite{DeHaan} estimate the main and interaction effects by overall mean subtraction. Hence, genes need to be treated as an additional factor. Meanwhile, in \cite{Smilde} and \cite{Nueda} implementations, the estimations are obtained on a gene-by-gene basis, as in (\ref{eq:anova}). Therefore, in a two-way factor experiment, such as $time \times oxygen$, De Haan's model includes two additional double interactions and a triple interaction, because genes are treated as a factor, unlike the models of Smilde and Nueda.

\subsection{The decomposition algorithm}
\label{sec:decomp}
The ANOVA model (\ref{eq:matrix}) is decomposed iteratively using (\ref{eq:linearmodel}), where in each step the $l-th$ coefficients $\hat{B}_{l},~\hat{E_{l}}$ matrices and $\hat{\sigma}^{2}_{l}$ are  estimated. Then, the particular term contribution matrix $\hat{X}_{l}=\hat{B}_{l}Z_{l}^\top$ is subtracted from the preceding residuals to feed the next model, as depicted in (\ref{eq:step}): 
\begin{eqnarray}
      X & = & X_{\mu}+ X_{\alpha}+X_{\beta}+X_{\alpha \beta}+E=\sum_{l\in\{\mu,\alpha, \beta, \alpha \beta\}}X_{l}+E \nonumber \\
 step~\mu: ~~~ X & = & X_{\mu} + E_{\mu} \Rightarrow X  = \hat{B}_{\mu}Z_{\mu}^{\top}+\hat{E}_{\mu} \Rightarrow \hat{E}_{\mu} = X-\hat{B}_{\mu}Z^{\top}_{\mu}\nonumber\\  
 step~\alpha: ~~ E_{\mu} & = & X_{\alpha} + E_{\alpha} \Rightarrow \hat{E}_{\mu} = \hat{B}_{\alpha}Z_{\alpha}^{\top}+\hat{E}_{\alpha} \Rightarrow \hat{E}_{\alpha} = \hat{E}_{\mu}-\hat{B}_{\alpha}Z^{\top}_{\alpha}\nonumber\\
 \vdots & & \vdots \nonumber\\
 \label{eq:step} 
 step~l: E_{l-1} & = & X_{l} + E_{l} \Rightarrow \hat{E}_{l-1} = \hat{B}_{l}Z_{l}^{\top}+\hat{E}_{l} \Rightarrow \hat{E}_{l} = \hat{E}_{l-1}-\hat{B}_{l}Z^{\top}_{l} \\
 \vdots & & \vdots \nonumber\\
 step~\alpha \beta: ~~E_{\beta} & = & X_{\alpha \beta} + E \Rightarrow \hat{E}_{\beta	} = \hat{B}_{\alpha \beta}Z_{\alpha \beta}^{\top}+\hat{E} \Rightarrow \hat{E} = \hat{E}_{\beta}-\hat{B}_{\alpha \beta}Z^{\top}_{\alpha \beta} \nonumber  
\end{eqnarray}

Where the hat (``$^{\wedge}$'') denotes estimated coefficients. In this implementation, the first step always estimates the \emph{intercept} term, i.e., \code{formula=}$\sim$\code{1} in \proglang{R} style, with $\hat{B}_{\mu}=\hat{\mu}$ and $Z_{\mu}=1$. The following models will only include the $l-th$ factor without the intercept, i.e., \code{formula=}$\sim$\code{lth\_term-1}, where lth\_term stands for $\alpha$, $\beta$ or $\alpha \beta$ in this example. This procedure is quite similar to the one proposed by \cite{Harrington}.

\subsection{PCA and PLS analyses}
These methods explain the variance/covariance structure of a set of observations (e.g., genes) through a few linear combinations of variables (e.g., experimental conditions). Both methods can be applied to the $l-th$ ANOVA decomposed step of (\ref{eq:step}) to deal with different aspects:

\begin{itemize}
 \item PCA concerns with the \emph{variance} of a single matrix, usually with the main objectives of reducing and interpreting data. Accordingly, depending on the matrix to which it is applied, there are two possible methods: ASCA, when PCA is applied to \emph{coefficient} matrix, $\hat{B}_{l}$, \citep{Smilde}; and APCA when PCA is calculated on the \emph{residual}, $\hat{E}_{l-1}$. The latter is conceptually an ASCA and is usually applied to, $X_{l}+E$, i.e., the mean factor matrix $X_{l}$, plus the error of the fully decomposed model $E$ of (\ref{eq:anova}), as in \cite{DeHaan}. 

 \item PLS not only generalizes but also combines features from PCA and regression to explore the \emph{covariance} structure between input and some output matrices, as described by \cite{Abdi} and \cite{ShaweTaylor}. It is particularly useful when one or several dependent variables (outputs - $O$) must be predicted from a large and potentially highly correlated set of independent variables (inputs). In our implementation, the input can be either the \emph{coefficient} matrix $\hat{B}_{l}$ or the \emph{residual}  $\hat{E}_{l-1}$. According to the choice, the respective output matrix will be a diagonal \code{O=diag(nrow(}$\hat{B}_{l}$\code{))} or design matrix $O=Z_{l}$. In addition, users can specify their own output matrix, $O$, to verify a particular hypothesis. For instance, in functional genomics it could be the Gene Ontology class matrix as used in gene set enrichment analysis (GSEA) by \cite{Subramanian}. 
\end{itemize}
When working with the \emph{coefficient} matrix, the user will not have to worry about the expected number of components in $X$ (rank of the matrix, given the number of replicates per treatment level), as suggested by \cite{Smilde}, because the components are directly summarized in the coefficient $\hat{B}_{l}$ matrix. In addition, for both PCA/PLS, the \pkg{lmdme} package \citep{lmdme} also offers different methods to visualize results, e.g., \code{biplot}, \code{loadingplot} and \code{screeplot} or \code{leverage} calculation, in order to filter out rows/genes as in \cite{Tarazona}.

\section{Example}
In this section we provide an overview of \pkg{lmdme} package by \cite{lmdme}. The example consists of an application of the analysis of gene expression interaction pattern, where we address: How to define the model, undertake ANOVA decomposition, perform PCA/PLS analysis and visualize the results. \\
From here onwards, some outputs were removed for reasons of clarity and the examples were performed with \code{options(digits=4)}.

\subsection{Package overview}
The original data files for the first example are available at Gene Expression Omnibus \citep{GEO}, with accession GSE37761 and \pkg{stemHypoxia} package \citep{stemHypoxia} on the Bioconductor  website. In this dataset, \cite{PradoLopez} studied differentiation of human embryonic stem cells under hypoxia conditions. They measured gene expression at different time points under controlled oxygen levels. This experiment has a typical two-way ANOVA structure, where factor $A$ stands for ``\emph{time}'' with $a=3$ levels $\{0.5,~1,~5~days\}$, factor $B$  stands for ``\emph{oxygen}'' with $b=3$ levels $\{1,~5,~21\%\}$ and $r=2$ replicates, yielding a total of 18 samples. The remainder of the dataset was excluded in order to have a balanced design, as suggested by \cite{Smilde} to fulfil orthogonality assumptions in ANOVA decomposition.\\ 
First, we need to load \pkg{stemHypoxia} package to access \proglang{R} objects calling \code{data("stemHypoxia")}, which will then load the experimental \code{design} and gene expression intensities \code{M}.   

<<General R options for Sweave, echo=false,results=hide>>=
options(prompt="R> ", continue="+  ", width=70, useFancyQuotes=FALSE, digits=4)
@

<<Loading stemHypoxia, echo=true,results=hide>>=
library("stemHypoxia")
data("stemHypoxia") 
@

Now we manipulate the \code{design} object to maintain only those treatment levels which create a balanced dataset. Then, we change \code{rownames(M)} of each gene in \code{M}, with their corresponding \code{M\$Gene\_ID}.

<<Filtering stemHypoxia, echo=true,results=hide>>=
timeIndex<-design$time %in% c(0.5, 1, 5)  
oxygenIndex<-design$oxygen %in% c(1, 5, 21) 
design<-design[timeIndex & oxygenIndex, ]
design$time<-as.factor(design$time)  
design$oxygen<-as.factor(design$oxygen)
rownames(M)<-M$Gene_ID
M<-M[, colnames(M) %in% design$samplename]
@

Now we can explore microarray gene expression data present on the \code{M} matrix, with $g=40736$ rows (individuals/genes) and $n=18$ columns (samples/microarrays). In addition, the experimental \code{design} data.frame contains main effect columns (e.g., \emph{time} and \emph{oxygen}) and the sample names (\code{samplename}). A brief summary of these objects is shown using \code{head} function:

<<Exploring M and design objects, echo=true>>=
head(design)
head(M)[, 1:3]
@

Once the preprocessing of the experiment data is completed, \code{library("}\pkg{lmdme}\code{")} should be loaded. This instruction will automatically load the required packages: \pkg{limma} \citep{limma} and \pkg{pls} \citep{pls}. Once the data are loaded, the ANOVA decomposition of Section~\ref{sec:decomp} can be carried out using (\ref{eq:step}) calling \code{lmdme} function with the \code{model} formula, actual \code{data} and experimental \code{design}.

<<ANOVA decomposition for PradoLopez data, echo=true>>=
library("lmdme")
fit<-lmdme(model=~time*oxygen, data=M, design=design)
fit
@ 

The results of \code{lmdme} will be stored inside the \code{fit} object, which is an S4 \proglang{R} class. By invoking the \code{fit} object, a brief description of the \emph{data} and \emph{design} used are shown as well as the \code{Model} applied and a summary of the decomposition. This \code{data.frame} describes the applied \code{Formula} and \code{Names} for each \code{Step}, as well as the amount of estimated coefficients for each gene (\code{CoefCols}).\\
At this point, we can choose those subjects/genes in which at least one interaction coefficient is statistically different from zero ($F$~test on the coefficients) with a threshold $p$~value of 0.001 and perform ASCA on the interaction \emph{coefficient} \code{term}, and PLS against the identity matrix (default option).

<<ASCA and PLSR decomposition, echo=true>>=
id<-F.p.values(fit, term="time:oxygen")<0.001
decomposition(fit, decomposition="pca", type="coefficient", 
  term="time:oxygen", subset=id, scale="row")
fit.plsr<-fit
decomposition(fit.plsr, decomposition="plsr", type="coefficient", 
  term="time:oxygen", subset=id, scale="row")
@

These instructions will perform ASCA and PLS \code{decomposition} over the \code{scale="row"} version of the 305 selected subjects/genes (\code{subset=id}) on \code{fit} and \code{fit.plsr} object, respectively. The results will be stored inside these objects. In addition, we have explicitly indicated the decomposition \code{type="coefficient"} (default value) in order to apply it to the \code{coefficient} matrix, on \code{"time:oxygen"} interaction \code{term} ($\hat{B}_{\alpha \beta}$).\\ 
Now, we can visualize the associated \code{biplot}s (see Figure~\ref{fig:example1biplot} \subref{fig:ascabiplot} and \subref{fig:plsbiplot}). 

<<ASCA and PLSR biplots, echo=true>>=
biplot(fit, xlabs="o", expand=0.7)
biplot(fit.plsr, which="loadings", xlabs="o", 
  ylabs=colnames(coefficients(fit.plsr, term="time:oxygen")),
  var.axes=TRUE)
@

<<ASCA_biplot, fig=TRUE, results=hide, echo=false, include=FALSE>>=
biplot(fit,xlabs="o", mfcol=NULL, expand=0.7)
@

<<PLSR_biplot, fig=TRUE, results=hide, echo=false, include=FALSE>>=
biplot(fit.plsr, which="loadings", xlabs="o", 
  ylabs=colnames(coefficients(fit.plsr,term="time:oxygen")),
  var.axes=TRUE, mfcol=NULL)
@

% \begin{sidewaysfigure}
\begin{figure}[!t]
  \centering
  \subfigure[ANOVA simultaneous component analysis]{
      \includegraphics[width=0.47\textwidth]{lmdme-vignette-ASCA_biplot} 
      \label{fig:ascabiplot}
  }
  \subfigure[ANOVA partial least squares]{
      \includegraphics[width=0.47\textwidth]{lmdme-vignette-PLSR_biplot}
      \label{fig:plsbiplot}
  }
  \caption{Biplot on the decomposed interaction coefficients ($time \times oxygen$) on genes satisfying the $F$~test with $p$~value < 0.001. Notice that the interaction matrix in the ASCA model is of rank 9. Thus, 9 arrows are expected and the score of the 305 selected subjects are projected onto the space spanned by the first two principal components in Figure~\ref{fig:ascabiplot}. 
}    
  \label{fig:example1biplot}
\end{figure}
% \end{sidewaysfigure}

For visual clarity, \code{xlabs} are changed with the \code{"o"} symbol, instead of using the \code{rownames(M)} with manufacturer ids, and second axis with the \code{expand=0.7} option to avoid cutting off loading labels. In addition, PLS \code{biplot} is modified from the default \pkg{pls} behavior to obtain a graph similar to ASCA output (\code{which="loadings"}). Accordingly, \code{ylabs} is changed to match the corresponding \code{coefficients} of the interaction \code{term} and \code{var.axes} is set to \code{TRUE}.\\
The ASCA biplot of the first two components (see Figure~\ref{fig:ascabiplot}), explain over 70\% of the coefficient variance. The genes are arranged in an elliptical shape. Thus, it can be observed that some genes tend to interact with different combinations of time and oxygen. A similar behavior is observed in PLS biplot of Figure~\ref{fig:plsbiplot}.

\newpage 

The interaction effect on the \code{fit} object can also be displayed using the \code{loadingplot} function (see Figure~\ref{fig:loadignplot}). For every combination of two consecutive levels of factors (time and oxygen), the figure shows an interaction effect on the first component, which explains 50.61\% of the total variance of the ``time:oxygen'' term.

% 
% \clearpage
% 

\begin{figure}[!hb]
\begin{center}
<<Loadingplot, fig=TRUE, results=hide, echo=true, include=FALSE>>=
loadingplot(fit, term.x="time", term.y="oxygen")
@
  \includegraphics[width=0.45\textwidth]{lmdme-vignette-Loadingplot}
\end{center}
  \caption{ANOVA simultaneous component analysis \code{loadingplot} on genes satisfying the $F$~test with $p$~value < 0.001 on the interaction coefficients ($time \times oxygen$).}
  \label{fig:loadignplot}
\end{figure}

In the case of an ANOVA-PCA/PLS analysis, the user only needs to change the \code{type="residuals"} parameter in the \code{decomposition} function and perform a similar exploration.

\newpage

\section*{Acknowledgements}
\emph{Funding}: This work was supported by the National Agency for Promoting Science and Technology, Argentina (PICT00667/07 to E.A.F. and PICT 2008-0807 BID to E.A.F.), C\'{o}rdoba Ministry of Science and Technology, Argentina (PID2008 to E.A.F and PIP2009 to M.G.B.), Catholic University of C\'{o}rdoba, Argentina and National Council of Scientific and Technical Research (CONICET), Argentina.

\bibliography{lmdme-vignette}

\newpage

\section*{Session Info}
<<Session Info, echo=true>>=
sessionInfo()
@

\end{document}

\docType{methods}
\name{lmdme}
\alias{lmdme}
\alias{lmdme,formula,ANY,data.frame-method}
\alias{lmdme-methods}
\title{High level constructor of lmdme class object}
\arguments{
  \item{model}{formula object to carry out the
  decomposition.}

  \item{data}{matrix or data.frame with individuals/genes
  (per rows) and samples/conditions (per columns).}

  \item{design}{data.frame with the design of the
  experiment, (rows) samples/conditions as in data columns
  and as many columns to indicate the factors present in
  each sample.}

  \item{Bayes}{Should limma estimate empirical Bayes
  statistics, i. e., moderated t-statistics? Default value
  is FALSE.}

  \item{verbose}{Should the process progress be printed?
  Default value is FALSE.}

  \item{...}{Additional parameters for \code{\link{lmFit}}
  function.}
}
\value{
  \item{lmdme}{lmdme class object with the corresponding
  completed slots according to the given model}
}
\description{
  Linear model ANOVA decomposition of Designed Multivariate
  Experiments based on limma \code{\link{lmFit}}
  implementation. For example in a two factor experimental
  design with interaction, the linear model of the i-th
  observation (gene) can be written: \cr
  \eqn{X=\mu+A+B+AB+\epsilon} \cr where \itemize{ \item X
  stands for the observed value \item the intercept
  \eqn{\mu} \item A, B and AB are the first, second and
  interaction terms respectively \item The error term
  \eqn{\epsilon ~ N(0,\sigma^2)}. } The model is
  iteratively decomposed in a step by step fashion
  decomposing one term each time: \enumerate{ \item The
  intercept is estimated using \eqn{X=\mu+E_1} \item The
  first factor (A) using \eqn{E_1=A+E_2} \item The second
  factor (B) using \eqn{E_2=B+E_3} \item The interaction
  (AB) using \eqn{E_3=AB+E_4}. } For each decomposed step
  the model, residuals, coefficients, p-values and F-value
  are stored in a list container, so their corresponding
  length is equal to the number of model terms + 1 (the
  intercept).
}
\section{Note}{
  use \bold{\code{\link{lmdme}}} high level constructor for
  the creation of the class instead of directly calling its
  constructor by means of new.
}
\examples{
{
data(stemHypoxia)

##Just to make a balanced dataset in the Fisher sense (2 samples per
## time*oxygen levels)
design<-design[design$time \%in\% c(0.5,1,5) & design$oxygen \%in\% c(1,5,21), ]
design$time<-as.factor(design$time)
design$oxygen<-as.factor(design$oxygen)
rownames(M)<-M[, 1]

#Keeping appropriate samples only
M<-M[, colnames(M) \%in\% design$samplename]

##ANOVA decomposition
fit<-lmdme(model=~time+oxygen+time:oxygen, data=M, design=design)
}
}
\author{
  Cristobal Fresno and Elmer A Fernandez
}
\references{
  \enumerate{ \item Smyth, G. K. (2005). Limma: linear
  models for microarray data. In: Bioinformatics and
  Computational Biology Solutions using R and Bioconductor.
  R. Gentleman, V. Carey, S. Dudoit, R. Irizarry, W.  Huber
  (eds), Springer, New York, pages 397--420. 
  \item Cristobal Fresno, Monica G. Balzarini, Elmer A. 
  Fernandez (2014) lmdme: Linear Models on Designed 
  Multivariate Experiments in R, Journal of Statistical 
  Software, 56(7), 1-16, http://www.jstatsoft.org/v56/i07/.}
}
\seealso{
  \code{\link{decomposition}}, \code{\link{lmFit}}
}

\docType{methods}
\name{decomposition}
\alias{decomposition}
\alias{decomposition,lmdme-method}
\alias{decomposition-methods}
\title{\code{decomposition} of lmdme object}
\arguments{
  \item{object}{lmdme class object.}

  \item{decomposition}{character to indicate the
  decomposition to be carried out, i.e., \emph{"pca"} or
  \emph{"plsr"}. Default value is "pca".}

  \item{term}{character specifying the model term to
  perform the decomposition (e.g. "time" or
  "time:concentration" for interaction term). If the term
  is not specified (i.e. missing) it performs the analysis
  over all the model terms.}

  \item{subset}{subset of individuals (rows) to be included
  in the analysis. By default all the individuals are
  included.}

  \item{type}{character to indicate on which regression
  matrix ("coefficient" or "residual") the decomposition
  will be performed. The intercept term is not included in
  the results, as it can be directly analyzed with the
  original M data.frame. Default value is "coefficient"
  a.k.a. ASCA. Note that "residual" performs PCA or PLS on
  the i-th residual \eqn{E_{i-1}=X_{i}+E_{i}} and not the
  residuals of the i-th model \eqn{E_{i}}.}

  \item{scale}{character "row", "column" or "none" to
  indicate if the matrix should be scaled by the row,
  column or not respectively. Default value is "none".}

  \item{Omatrix}{the output matrix for PLSR only. If the
  parameter is missing, the output matrix will be an
  identity matrix for the ASCA. Otherwise, is the design
  matrix corresponding to the specified term for APCA.}

  \item{...}{additional parameters for \code{\link{prcomp}}
  or \code{\link{plsr}} functions, according to the
  decomposition call.}
}
\value{
  Internal update of the "components" slot of the lmdme
  object, which is a list of \code{\link{prcomp}} or a list
  of mvr (\code{\link{plsr}}) objects using the given term
  parameter. If missing(term), the length of the list
  equals the number of decomposed models minus the
  Intercept term for coefficients or the length of
  decomposed models for residual decomposition.
}
\description{
  This function calculates the decomposition of variance or
  covariance structure using Principal Component Analysis
  (PCA) or Partial Least Squared Regression (PLSR), on the
  ANOVA decomposed lmdme object. In this context, in a two
  factor experimental design with interaction, the linear
  model of the i-th observation (gene) can be written: \cr
  \eqn{X=\mu+X_{A}+X_{B}+X_{AB}+\epsilon} \cr where
  \itemize{ \item X stands for the observed value. \item
  the intercept \eqn{\mu}. \item \eqn{X_{A}}, \eqn{X_{B}}
  and \eqn{X_{AB}} are the first, second and interaction
  coefficients respectively. \item The error term
  \eqn{\epsilon ~ N(0,\sigma^2)}. } The model is
  iteratively decomposed in a step by step fashion,
  decomposing one term each time by calling
  \code{\link{lmdme}} constructor: \enumerate{ \item Step
  1: \eqn{X=\mu+E_{1}} \item Step 2:
  \eqn{E_{1}=X_{A}+E_{2}} \item Step 3:
  \eqn{E_{2}=X_{B}+E_{3}} \item Step 4:
  \eqn{E_{3}=X_{AB}+E_{4}} } Then, if we apply PCA on the
  i-th step using \eqn{E_{i-1}} matrix it is known as
  \emph{APCA} but if applied on the coefficients
  \eqn{X_{i}} it is called \emph{ASCA}. The same
  decomposition schema can also be used with PLSR.
}
\examples{
{
data(stemHypoxia)

##Just to make a balanced dataset in the Fisher sense (2 samples per
## time*oxygen levels)
design<-design[design$time \%in\% c(0.5,1,5) & design$oxygen \%in\% c(1,5,21), ]
design$time<-as.factor(design$time)
design$oxygen<-as.factor(design$oxygen)
rownames(M)<-M[, 1]

#Keeping appropriate samples only
M<-M[, colnames(M) \%in\% design$samplename]

##ANOVA decomposition
fit<-lmdme(model=~time+oxygen+time:oxygen, data=M, design=design)

##Just a copy of the same fit object and to perform analysis on those
##subjects/genes where at least one interaction coefficient is statistically
##different from zero (F-test on the coefficients).
asca<-fit
apca<-fit
id<-F.p.values(fit, term="time:oxygen")<0.001

##ASCA and APCA decomposition for every available term.
decomposition(asca, decomposition="pca", subset=id, scale="row")
decomposition(apca, decomposition="pca", subset=id, scale="row",
type="residual")

##Let's get the components for asca/apca decomposed objects
asca<-components(asca)
apca<-components(apca)

##Now let's try the PLSR decomposition for residuals and coefficients
plsr.residuals<-fit
plsr.coefficients<-fit
decomposition(plsr.coefficients, decomposition="plsr", subset=id,
scale="row")
decomposition(plsr.residuals, decomposition="plsr", subset=id, scale="row",
type="residual")

##Obtain the coefficients for decomposed plsr objects
##(coefficients/residuals)
plsr.coefficients<-components(plsr.coefficients)
plsr.residuals <- components(plsr.residuals)
}
}
\author{
  Cristobal Fresno and Elmer A Fernandez
}
\references{
  \enumerate{ \item Smilde AK, Jansen JJ, Hoefsloot HCJ,
  Lamer RAN, Van der Greef J, Timmerman ME (2005)
  ANOVA-simultaneous component analysis (ASCA): a new tool
  for analyzing designed meta-bolomics data, Bioinformatics
  21,13,3043 DOI:/10.1093/bioinformatics/bti476 \item
  Zwanenburg G, Hoefsloot HCJ, Westerhuis JA, Jansen JJ,
  Smilde AK (2011) ANOVA Principal component analysis and
  ANOVA-simultaneous component analysis: a comparison J.
  Chemometrics 25:561-567 DOI:10.1002/cem.1400 
  \item Cristobal Fresno, Monica G. Balzarini, Elmer A. 
  Fernandez (2014) lmdme: Linear Models on Designed 
  Multivariate Experiments in R, Journal of Statistical 
  Software, 56(7), 1-16, http://www.jstatsoft.org/v56/i07/.}
}
\seealso{
  \code{\link{prcomp}}, \code{\link{plsr}}
}

\docType{methods}
\name{fitted.values}
\alias{F.p.values}
\alias{F.p.values,lmdme-method}
\alias{F.p.values-methods}
\alias{coef}
\alias{coef,lmdme-method}
\alias{coefficients}
\alias{coefficients,lmdme-method}
\alias{components}
\alias{components,lmdme-method}
\alias{components-methods}
\alias{componentsType}
\alias{componentsType,lmdme-method}
\alias{componentsType-methods}
\alias{design}
\alias{design,lmdme-method}
\alias{design-methods}
\alias{fitted}
\alias{fitted,lmdme-method}
\alias{fitted.values}
\alias{fitted.values,lmdme-method}
\alias{model}
\alias{model,lmdme-method}
\alias{model-methods}
\alias{modelDecomposition}
\alias{modelDecomposition,lmdme-method}
\alias{modelDecomposition-methods}
\alias{p.values}
\alias{p.values,lmdme-method}
\alias{p.values-methods}
\alias{resid}
\alias{resid,lmdme-method}
\alias{residuals}
\alias{residuals,lmdme-method}
\title{Getters for lmdme object}
\usage{
  \S4method{fitted.values}{lmdme}(object, term=NULL,
  drop=TRUE)

  \S4method{fitted}{lmdme}(object, term=NULL, drop=TRUE)

  \S4method{coef}{lmdme}(object, term=NULL, drop=TRUE)

  \S4method{coefficients}{lmdme}(object, term=NULL,
  drop=TRUE)

  \S4method{resid}{lmdme}(object, term=NULL, drop=TRUE)

  \S4method{residuals}{lmdme}(object, term=NULL, drop=TRUE)

  F.p.values(object, term=NULL, drop=TRUE)

  \S4method{F.p.values}{lmdme}(object, term=NULL,
  drop=TRUE)

  p.values(object, term=NULL, drop=TRUE)

  \S4method{p.values}{lmdme}(object, term=NULL, drop=TRUE)

  modelDecomposition(object, term=NULL, drop=TRUE)

  \S4method{modelDecomposition}{lmdme}(object, term=NULL,
  drop=TRUE)

  components(object, term=NULL, drop=TRUE)

  \S4method{components}{lmdme}(object, term=NULL,
  drop=TRUE)

  componentsType(object)

  \S4method{componentsType}{lmdme}(object)

  model(object)

  \S4method{model}{lmdme}(object)

  design(object)

  \S4method{design}{lmdme}(object)
}
\arguments{
  \item{object}{lmdme class object.}

  \item{term}{character with the corresponding term/s to
  return. Default value is NULL in order to return every
  available term/s.}

  \item{drop}{should try to drop list structure if
  length==1? Default value is TRUE}
}
\value{
  according to the call one of the following objects can be
  returned \item{design}{experiment design data.frame
  used.} \item{model}{decomposed formula used.}
  \item{modelDecomposition}{list of decomposed model
  formulas.} \item{residuals, resid, coef, coefficients,
  fitted, fitted.values, p.values or F.p.values}{list of
  appropriate slot where each item is a matrix that will
  have G rows (individuals) x k columns (levels of the
  corresponding model term).} \item{components}{list with
  corresponding PCA or PLSR terms according to the
  decomposition function call.}
  \item{componentsType}{character name vector with the
  information of the component calculations.}
}
\description{
  To obtain lmdme slot information, according to the given
  function call (see Values). If a term parameter is not
  specified, it will return all the available terms.
  Otherwise, just the one specified.
}
\examples{
{
data(stemHypoxia)

##Just to make a balanced dataset in the Fisher sense (2 samples per
## time*oxygen levels)
design<-design[design$time \%in\% c(0.5, 1, 5) & design$oxygen \%in\% c(1,5,21),]
design$time<-as.factor(design$time)
design$oxygen<-as.factor(design$oxygen)
rownames(M)<-M[, 1]

##Keeping appropriate samples only
M<-M[, colnames(M) \%in\% design$samplename]

##ANOVA decomposition
fit<-lmdme(model=~time+oxygen+time:oxygen, data=M, design=design)

##Let's inspect how the decomposition process was carried out:
##a) The model formula used
##b) The design data.frame used
##c) The decomposition itself
fit.model<-model(fit)
fit.design<-design(fit)
fit.modelDecomposition<-modelDecomposition(fit)

##Getting the specific "time" term coefficients, p-values or F-values.
## Omit "term" parameter for all available terms.
timeCoef<-coef(fit,term="time")
fit.p.values<-p.values(fit,term="time")
fit.f.values<-F.p.values(fit,term="time")

##Getting the residuals or fitted values, for the interaction "time:oxygen"
## term. Omit "term" parameter for all available terms.
interactionResid<-resid(fit, term="time:oxygen")
interactionFit<-fitted(fit, term="time:oxygen")
}
}
\author{
  Cristobal Fresno and Elmer A Fernandez
}
\seealso{
  \code{\link{lmdme}}, \code{\link{decomposition}},
  \code{\link{print}}, \code{\link{show}}
}

\docType{methods}
\name{print}
\alias{print}
\alias{print,lmdme-method}
\alias{show}
\alias{show,lmdme-method}
\alias{summary}
\alias{summary,lmdme-method}
\title{\code{Show}, \code{Print} or \code{Summary} a lmdme object}
\usage{
  \S4method{print}{lmdme}(x, term)

  \S4method{show}{lmdme}(object)

  \S4method{summary}{lmdme}(object)
}
\arguments{
  \item{x}{lmdme class object.}

  \item{object}{lmdme class object.}

  \item{term}{character with the corresponding term to
  return. Default value is NULL to return every decomposed
  term (if more than one is available).}
}
\value{
  according to the call \item{print, show or
  summary:}{console output text with increasing detail of
  lmdme object.} \item{show or summary}{console output text
  of the lmdme object, plus a data.frame with model
  decomposition summary data.}
}
\description{
  Generic Show/Print/Summary method for lmdme class output
  visualization.
}
\examples{
{
data(stemHypoxia)

##Just to make a balanced dataset in the Fisher sense (2 samples per
## time*oxygen levels)
design<-design[design$time \%in\% c(0.5, 1, 5) & design$oxygen \%in\% c(1,5,21),]
design$time<-as.factor(design$time)
design$oxygen<-as.factor(design$oxygen)
rownames(M)<-M[, 1]

##Keeping appropriate samples only
M<-M[, colnames(M) \%in\% design$samplename]

##ANOVA decomposition
fit<-lmdme(model=~time+oxygen+time:oxygen, data=M, design=design)
}
\dontrun{
#equivalent to call show(fit)
fit
print(fit)
summary(fit)
}
}
\author{
  Cristobal Fresno and Elmer A Fernandez
}
\seealso{
  \code{\link{lmdme}}, \code{\link{coef}},
  \code{\link{resid}}, \code{\link{fitted}},
  \code{\link{modelDecomposition}},
  \code{\link{components}}, \code{\link{componentsType}}
}

\docType{methods}
\name{p.adjust}
\alias{lmdme-padjust}
\alias{p.adjust}
\alias{p.adjust,ANY-method}
\alias{p.adjust,lmdme-method}
\alias{p.adjust-methods}
\title{\code{p.adjust} of p-values for Multiple Test Comparison Corrections}
\usage{
  \S4method{p.adjust}{lmdme}(p, term=NULL,
  method=p.adjust.methods, drop=TRUE)
}
\arguments{
  \item{p}{numeric vector of p-values as in stats::p.adjust
  or lmdme class object.}

  \item{method}{correction method available in
  \code{\link{p.adjust.methods}}.}

  \item{term}{character with the corresponding term to
  return.}

  \item{...}{other arguments.}

  \item{drop}{should try to drop the list structure if
  length==1? Default value is TRUE}
}
\value{
  according to the call, one of the following objects can
  be returned \item{numeric}{vector of adjusted p-values.}
  \item{matrix}{for lmdme object If term!=NULL, the
  corresponding character is looked up within the list of
  p.values returning the associated matrix of G rows
  (individuals) x k columns (levels of the corresponding
  model term) with the adjusted p-values.}
}
\description{
  Given a set of p-values, returns adjusted p-values using
  one of several methods.
}
\examples{
{
data(stemHypoxia)

##Just to make a balanced dataset in the Fisher sense (2 samples per
## time*oxygen levels)
design<-design[design$time \%in\% c(0.5, 1, 5) & design$oxygen \%in\% c(1,5,21),]
design$time<-as.factor(design$time)
design$oxygen<-as.factor(design$oxygen)
rownames(M)<-M[, 1]

##Keeping appropriate samples only
M<-M[, colnames(M) \%in\% design$samplename]

##ANOVA decomposition
fit<-lmdme(model=~time+oxygen+time:oxygen, data=M, design=design)

##Adjust p-values only on the interaction p.values using false discovery rate
## method
pInteraction<-p.values(fit, term="time:oxygen")
FDRInteraction<-p.adjust(fit, term="time:oxygen", method="fdr")
corrected<-sum(pInteraction < 0.05) - sum(FDRInteraction < 0.05)
}
}
\author{
  Cristobal Fresno and Elmer A Fernandez
}
\seealso{
  \code{\link{p.adjust}}, \code{\link{p.adjust.methods}}
}

\docType{methods}
\name{biplot}
\alias{biplot}
\alias{biplot,lmdme-method}
\title{Plot a \code{biplot} of a lmdme object}
\usage{
  \S4method{biplot}{lmdme}(x, comp=1:2, xlab=NULL,
  ylab=NULL, term=NULL, mfcol, xlabs, ylabs, which, ...)
}
\arguments{
  \item{x}{lmdme class object.}

  \item{comp}{a two component vector with the PC components
  to plot. Default comp=1:2.}

  \item{xlab}{character for the x-label title for PCA
  biplots.}

  \item{ylab}{character for the y-label title for PCA
  biplots.}

  \item{term}{character with the corresponding term/s for
  biploting. Default value is NULL in order to obtain every
  available biplot/s.}

  \item{mfcol}{numeric vector for par layout. If missing
  mfcol=c(1,2) will be used if more than one biplot is
  available. Use mfcol==NULL to override par call inside
  biplot function.}

  \item{xlabs,ylabs}{vector of character strings to label
  the first/second set of points. The default is to use
  dimname of "x"/"y", or "1:n" if the dimname is NULL for
  the respective set of points. If a single character is
  passed e.g. "o", the same character is used for all the
  points.}

  \item{which}{character to indicate the type of biplot to
  use when plsr decomposition is applied. Default value is
  "x" (X scores and loadings), "y" for (Y scores and
  loadings), "scores" (X and Y scores) or "loadings" (X and
  Y loadings). See \code{\link{biplot.mvr}} for details.}

  \item{...}{additional parameters for
  \code{\link{biplot.prcomp}}(pca) or
  \code{\link{biplot.mvr}}(plsr)}
}
\value{
  plotted biplot/s of the component/s of the given lmdme
  object. If \code{\link{par}}() is called before this
  function, the biplots can be arranged in the same window
}
\description{
  Plot a biplot over each decomposed "pca" or "plsr"
  present in lmdme component object's slot.
}
\examples{
{
data(stemHypoxia)

##Just to make a balanced dataset in the Fisher sense (2 samples per
## time*oxygen levels)
design<-design[design$time \%in\% c(0.5,1,5) & design$oxygen \%in\% c(1,5,21), ]
design$time<-as.factor(design$time)
design$oxygen<-as.factor(design$oxygen)
rownames(M)<-M[, 1]

#Keeping appropriate samples only
M<-M[, colnames(M) \%in\% design$samplename]

##ANOVA decomposition
fit<-lmdme(model=~time+oxygen+time:oxygen, data=M, design=design)

##ASCA for all the available terms, over those subjects/genes where at least
##one interaction coefficient is statistically different from zero (F-test
##on coefficients).
id<-F.p.values(fit, term="time:oxygen")<0.001
decomposition(fit, decomposition="pca",scale="row",subset=id)

\dontrun{
##Does not call par inside
par(mfrow=c(2,2))
biplot(fit, xlabs="o", mfcol=NULL)

##Just the term of interest
biplot(fit, xlabs="o", term="time")

##In separate graphics
biplot(fit, xlabs="o", term=c("time", "oxygen"), mfcol=c(1,1))

##All terms in the same graphic
biplot(fit, xlabs="o", mfcol=c(1,3))
}
}

##Now using plsr on interaction coefficients
decomposition(fit, decomposition="plsr", term="time:oxygen", scale="row",
subset=id)

\dontrun{
par(mfrow=c(2,2))

##plsr biplot by default which="x"
biplot(fit, which="x", mfcol=NULL)

##Other alternatives to which
biplot(fit, which="y", mfcol=NULL)
biplot(fit, which="scores", mfcol=NULL)
biplot(fit, which="loadings", mfcol=NULL, xlabs="o")
}
}
\author{
  Cristobal Fresno and Elmer A Fernandez
}
\seealso{
  \code{\link{prcomp}}, \code{\link{plsr}},
  \code{\link{biplot.princomp}}, \code{\link{biplot.mvr}}
}

\name{lmdme-class}
\alias{lmdme-class}
\title{lmdme S4 class: Linear Model decomposition for Designed Multivariate
Experiments.}
\description{
  Linear Model ANOVA decomposition of Designed Multivariate
  Experiments based on limma \code{\link{lmFit}}
  implementation. For example in a two factor experimental
  design with interaction, the linear model of the i-th
  observation (gene) can be written: \cr
  \eqn{X=\mu+A+B+AB+\epsilon} \cr where \itemize{ \item X
  stands for the observed value \item The intercept
  \eqn{\mu} \item A, B and AB are the first, second and
  interaction terms respectively \item The error term
  \eqn{\epsilon ~ N(0,\sigma^2)}. } The model is iterative
  decomposed in a step by step fashion decomposing one term
  at each time: \enumerate{ \item The intercept is
  estimated using \eqn{X=\mu+E_1} \item The first factor
  (A) using \eqn{E_1=A+E_2} \item The second factor (B)
  using \eqn{E_2=B+E_3} \item The interaction (AB) using
  \eqn{E_3=AB+E_4}. } For each decomposed step the model,
  residuals, coefficients, p-values and F-values are stored
  in a list container, so their corresponding length is
  equal to the number of model terms + 1 (the intercept).
}
\section{Features}{
  \enumerate{ \item Flexible formula type interface, \item
  Fast limma based implementation based on
  \code{\link{lmFit}}, \item p values for each estimated
  coefficient levels in each factor \item F values for
  factor effects \item Plotting functions for PCA and PLS.
  }
}

\section{Slots}{
  \itemize{ \item design: data.frame with experimental
  design. \item model: formula with the designed model to
  be decomposed. \item modelDecomposition: list with the
  model formula obtained for each decomposition step. \item
  residuals: list of residual matrices G rows(genes) x N
  columns (arrays-designed measurements). \item
  coefficients: list of coefficient matrices. Each matrix
  will have G rows(genes) x k columns(levels of the
  corresponding model term). \item p.values: list of
  p-value matrices. \item F.p.values: list with
  corresponding F-p-values vectors for each individual.
  \item components: list with corresponding PCA or PLS
  components for the selected term/s. \item componentsType:
  name character vector to keep process trace of the
  variance/covariance components slot: decomposition ("pca"
  or "pls"), type ("apca" for ANOVA-PCA or "asca" for
  ANOVA-SCA) and scale ("none", "row" or "column") }
}

\section{lmdme-general-functions}{
  \describe{ \item{print, show}{Basic output for lmdme
  class} \item{summary}{Basic statistics for lmdme class}
  \item{design, model, modelDecomposition, residuals and
  coefficients}{Getters for their respective slots.}
  \item{p.values, F.p.values, components and
  componentsType}{Getters for their respective slots.} }
}

\section{ANOVA-linear-decomposition-functions}{
  \describe{ \item{lmdme}{Function that produces the
  complete ANOVA decomposition based on model specification
  through a formula interface. Technically it's a high
  level wrapper of the initialize function.}
  \item{modelDecomposition}{Getter for the used decomposed
  formula in each step} \item{p.adjust}{Adjust coefficients
  p-values for the Multiple Comparison Tests.}
  \item{Fpvalues, pvalues}{Getters for the corresponding
  associated decomposed model coefficient statistics in
  each step, for each observation.} \item{residuals, resid,
  coef, coefficients, fitted.values, fitted}{Getters for
  the corresponding decomposed model in each step.}
  \item{permutation}{Produces the specified lmdme in
  addition to the required permuted objects (sampling the
  columns of data), using the same parameters to fit the
  model.} }
}

\section{variance-covariance-decomposition-functions}{
  \describe{ \item{decomposition}{Function to perform PCA
  or PLS on the ANOVA decomposed terms. PCA can be
  performed on \eqn{E_1}, \eqn{E_2} or \eqn{E_3} and it is
  referred to, as ANOVA-PCA (APCA) but, if it is performed
  on the coefficients it is referred to, as ANOVA-SCA
  (ASCA). On the other hand PLSR is based on pls library
  and if it is performed on coefficients (ASCA like) it
  uses the identity matrix for output co-variance
  maximization or can be carried out on the \eqn{E_{1,2 or
  3}} (APCA like) using the design matrix as the output.}
  \item{components}{Getter for PCA or PLS decomposed
  models.} \item{componentsType}{Getter for componentsType
  slot.} \item{leverage}{Leverage calculation on PCA (APCA
  or ASCA) terms.} \item{biplot}{Biplots for PCA or PLSR
  decomposed terms.} \item{screeplot}{Screeplot on each PCA
  decomposed term.} \item{loadingplot}{Loadingplot for PCA
  interaction terms.} }
}
\author{
  Cristobal Fresno and Elmer A Fernandez
}
\references{
  \enumerate{ \item Smilde AK, Jansen JJ, Hoefsloot HCJ,
  Lamer RAN, Van der Greef J, Timmerman ME (2005)
  ANOVA-simultaneaus component analysis (ASCA): a new tool
  for analyzing designed \cr metabolomics data,
  Bioinformatics 21,13,3043
  DOI:/10.1093/bioinformatics/bti476 \item Zwanenburg G,
  Hoefsloot HCJ, Westerhuis JA, Jansen JJ, Smilde AK (2011)
  ANOVA.Principal component analysis and ANOVA-simultaneaus
  component analysis: a comparison J. \cr Chemometrics
  25:561-567 DOI:10.1002/cem.1400 \item Tarazona S,
  Prado-Lopez S, Dopazo J, Ferrer A, Conesa A (2012)
  Variable Selection for Multifactorial Genomic Data,
  Chemometrics and Intelligent Laboratory Systems,
  110:113-122 }
}
\seealso{
  \code{\link{lmdme}}, \code{\link{decomposition}},
  \code{\link{biplot}}, \code{\link{loadingplot}} and
  additional related lmdme class functions.
}

\docType{methods}
\name{screeplot}
\alias{screeplot}
\alias{screeplot,lmdme-method}
\title{Plot a \code{screeplot} of a PCA decomposed lmdme object}
\usage{
  \S4method{screeplot}{lmdme}(x, independent=TRUE,
  col=seq(along=components(x)), npcs, term=NULL, mfcol,
  ...)
}
\arguments{
  \item{x}{lmdme class object.}

  \item{independent}{logical indicating whether the
  screeplots should be plotted together. Default value is
  FALSE.}

  \item{col}{which color to use for each decomposed model.
  Default value seq(along= components(x)).}

  \item{npcs}{integer with the number of components to
  plot. By default all present components are plotted.}

  \item{term}{character with the corresponding term/s for
  biploting. Default value is NULL in order to obtain every
  available biplot/s.}

  \item{mfcol}{numeric vector for par layout. If missing,
  mfcol=c(1,2) will be used if more than one biplot is
  available. Use mfcol==NULL to override par call inside
  biplot function.}

  \item{...}{additional parameters for screeplot or
  plot/lines according to independent FALSE or TRUE
  respectively.}
}
\value{
  plotted screeplot/s of the components slot if PCA
  decomposition was applied.
}
\description{
  Screeplot on each decomposed "pca" model present in lmdme
  components slot.
}
\examples{
{
data(stemHypoxia)

##Just to make a balanced dataset in the Fisher sense (2 samples per
## time*oxygen levels)
design<-design[design$time \%in\% c(0.5,1,5) & design$oxygen \%in\% c(1,5,21), ]
design$time <-as.factor(design$time)
design$oxygen<-as.factor(design$oxygen)
rownames(M)<-M[, 1]

#Keeping appropriate samples only
M<-M[, colnames(M) \%in\% design$samplename]

##ANOVA decomposition
fit<-lmdme(model=~time+oxygen+time:oxygen, data=M, design=design)

##ASCA for all the available terms, on those subjects/genes where at least
##one interaction coefficient is statistically different from zero (F-test
##on the coefficients).
id<-F.p.values(fit,term="time:oxygen")<0.001
decomposition(fit, decomposition="pca", scale="row", subset=id)

\dontrun{
par(mfrow=c(2,2))

##Does not call par inside
screeplot(fit,mfcol=NULL)

##Just the term of interest
screeplot(fit,term="time")

##In separate graphics
screeplot(fit,term=c("time","oxygen"),mfcol=c(1,1))

##All term in the same graphic device
screeplot(fit,mfcol=c(1,3))

##All in the same graphic
screeplot(fit,independent=FALSE)
}
}
}
\author{
  Cristobal Fresno and Elmer A Fernandez
}
\seealso{
  stats::screeplot
}

\docType{methods}
\name{leverage}
\alias{leverage}
\alias{leverage,lmdme-method}
\alias{leverage-methods}
\title{\code{leverage} test of lmdme objects}
\arguments{
  \item{object}{lmdme class object.}

  \item{comps}{a numeric vector indicating the PCA
  component indexes to keep. Default the first two
  components (1:2).}

  \item{term}{a character specifying the model term.}

  \item{level}{the quantile level. Default value 0.95}
}
\value{
  data.frame with the following fields
  \item{leverage}{numeric for the corresponding row
  leverage} \item{over}{logical indicating if the leverage
  > quantile(leverage,level) for the given decomposed term}
}
\description{
  This function calculates the leverage test for each
  individual using the Principal Component Analysis (comps
  function) on the coefficients of the given decomposed
  model term.
}
\examples{
{
data(stemHypoxia)

##Just to make a balanced dataset in the Fisher sense (2 samples per
## time*oxygen levels)
design<-design[design$time \%in\% c(0.5, 1, 5) & design$oxygen \%in\% c(1,5,21),]
design$time<-as.factor(design$time)
design$oxygen<-as.factor(design$oxygen)
rownames(M)<-M[, 1]

##Keeping appropriate samples only
M<-M[, colnames(M) \%in\% design$samplename]

##ANOVA decomposition
fit<-lmdme(model=~time+oxygen+time:oxygen, data=M, design=design)

##Leverages for the first two Principal Components and q95 (default value).
##Leverages for the first three Principal Components and q99.
leverages2PCDefault<-leverage(fit, term="time:oxygen")
leverages3PCq99<-leverage(fit, comps=1:3, term="time:oxygen", level=0.99)
}
}
\author{
  Cristobal Fresno and Elmer A Fernandez
}
\references{
  Tarazona S, Prado-Lopez S, Dopazo J, Ferrer A, Conesa A,
  Variable Selection for Multifactorial Genomic Data,
  Chemometrics and Intelligent Laboratory Systems,
  110:113-122 (2012)
}
\seealso{
  \code{\link{prcomp}}, \code{\link{quantile}}
}

\docType{methods}
\name{loadingplot}
\alias{loadingplot}
\alias{loadingplot,lmdme-method}
\title{\code{loadingplot} of interaction PCA decomposed lmdme object}
\usage{
  \S4method{loadingplot}{lmdme}(object, term.x, term.y,
  pc=1, ord.x, col, ...)
}
\arguments{
  \item{object}{lmdme class object.}

  \item{term.x,term.y}{character indicating the model
  principal factor for the interaction term (term.x:term.y
  or term.y:term.x) for the corresponding x or y axis.}

  \item{pc}{integer indicating which principal component
  loading is to be plotted on the y-axis. Default value is
  1.}

  \item{col}{which color to use for each level present in
  term.y.}

  \item{ord.x}{numeric indicating the term.x levels order,
  for plotting purposes. If missing, the levels order is
  used.}

  \item{...}{additional parameters for matplot.}
}
\value{
  loading plot of the selected interaction (term.x:term.y)
  lmdme object's components slot, if PCA decomposition was
  applied.
}
\description{
  This function plots the PCA loadings for a given
  interaction (A:B) lmdme object's components slot, for the
  given "pc" component. The user can choose which term (A
  or B) is used for x-axis and y-axis functions (B or A)
  respectively.
}
\examples{
{
data(stemHypoxia)

##Just to make a balanced dataset in the Fisher sense (2 samples per
## time*oxygen levels)
design<-design[design$time \%in\% c(0.5,1,5) & design$oxygen \%in\% c(1,5,21), ]
design$time<-as.factor(design$time)
design$oxygen<-as.factor(design$oxygen)
rownames(M)<-M[, 1]

#Keeping appropriate samples only
M<-M[, colnames(M) \%in\% design$samplename]

##ANOVA decomposition
fit<-lmdme(model=~time+oxygen+time:oxygen, data=M, design=design)

##ASCA for all the available terms, on those subjects/genes where at least
##one interaction coefficient is statistically different from zero (F-test
##on the coefficients).
id<-F.p.values(fit, term="time:oxygen")<0.001
decomposition(fit, decomposition="pca", scale="row", subset=id)

\dontrun{
loadingplot(fit, term.x="time", term.y="oxygen")

##Or change the axis order
loadingplot(fit, term.x="oxygen", term.y="time")

##Or change the PC to display
loadingplot(fit, term.x="time", term.y="oxygen", pc=2)

##Or the order of x-levels
loadingplot(fit, term.x="time", term.y="oxygen", ord.x=3:1)
}
}
}
\author{
  Cristobal Fresno and Elmer A Fernandez
}

\docType{methods}
\name{permutation}
\alias{permutation}
\alias{permutation,formula,data.frame,data.frame-method}
\alias{permutation-methods}
\title{\code{permutation} of the specified lmdme object}
\usage{
  \S4method{permutation}{formula,data.frame,data.frame}(model,data,design,Bayes=FALSE,verbose=FALSE,NPermutations=100,nCpus=1,...)
}
\arguments{
  \item{model}{formula object to carry out the
  decomposition.}

  \item{data}{data.frame with individuals (rows) and
  samples/conditions (columns)}

  \item{design}{data.frame with the design of the
  experiment, (rows) samples/conditions as in data columns
  and as many columns to indicate the factors present in
  each sample.}

  \item{Bayes}{Should limma estimate empirical Bayes
  statistics, i.e., moderated t-statistics? Default value
  is FALSE.}

  \item{verbose}{Should the process progress be printed?
  Default value is FALSE.}

  \item{NPermutations}{number of permutations to be
  calculated. Default value is 100.}

  \item{nCpus}{number of cores to be used. Default value is
  1, i.e. sequential calculation.}

  \item{...}{Additional parameters for the
  \code{\link{lmFit}} function.}
}
\value{
  \item{list}{contains the original lmdme object plus the
  required amount of permuted versions.}
}
\description{
  Produces the specified lmdme plus the required permuted
  objects (sampling the columns), using the same parameters
  to fit the additional models.
}
\examples{
{
data(stemHypoxia)

##Just to make a balanced dataset in the Fisher sense (2 samples per
## time*oxygen levels)
design<-design[design$time \%in\% c(0.5, 1, 5) & design$oxygen \%in\% c(1,5,21),]
design$time<-as.factor(design$time)
design$oxygen<-as.factor(design$oxygen)
rownames(M)<-M[, 1]

##Keeping appropriate samples only
M<-M[, colnames(M) \%in\% design$samplename]

##Just to test if it works. In a real scenario, use NPermutations >= 100 if
##the conditions (columns) of M allow it. Verbose parameter is FALSE by
##default
permuted<-permutation(model=~time*oxygen, data=M, design=design,
NPermutations=2, nCpus=3)
}
}
\author{
  Cristobal Fresno and Elmer A Fernandez
}
\seealso{
  \code{\link{lmdme}}
}
